/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20060912
 *
 * Disassembly of ./dsdt-0702.dat, Sat Nov  3 22:42:33 2007
 *
 *
 * Original Table Header:
 *     Signature        "DSDT"
 *     Length           0x00007255 (29269)
 *     Revision         0x01
 *     OEM ID           "A0427"
 *     OEM Table ID     "A0427000"
 *     OEM Revision     0x00000000 (0)
 *     Creator ID       "INTL"
 *     Creator Revision 0x02002026 (33562662)
 */
DefinitionBlock ("./dsdt-0702.aml", "DSDT", 1, "A0427", "A0427000", 0x00000000)
{
    Name (T00, 0x00)
    Name (DP80, 0x80)
    Name (DP90, 0x90)
    Name (SSMI, 0x082E)
    Name (SSEP, 0x99)
    Name (SSEN, 0x00)
    Name (APIC, 0x01)
    Name (PMBS, 0x0500)
    Name (PMLN, 0x0100)
    Name (SCBS, 0x0800)
    Name (SCLN, 0x0100)
    Name (ACBS, 0x0900)
    Name (ACLN, 0x0100)
    Name (IGPB, 0x00)
    Name (IGLN, 0x0100)
    Name (ACA4, 0x05A4)
    Name (SCIO, 0x0800)
    Name (SCTL, 0x0590)
    Name (EXTS, 0x00)
    Name (IGPS, 0x00)
    Name (IGPM, 0x00)
    Name (IGPL, 0x00)
    Name (PCIB, 0xE0000000)
    Name (PCIL, 0x10000000)
    Name (SMBS, 0x0600)
    OperationRegion (BIOS, SystemMemory, 0x7FFCE064, 0xFF)
    Field (BIOS, ByteAcc, NoLock, Preserve)
    {
        SS1,    1, 
        SS2,    1, 
        SS3,    1, 
        SS4,    1, 
                Offset (0x01), 
        IOST,   16, 
        TOPM,   32, 
        ROMS,   32, 
        MG1B,   32, 
        MG1L,   32, 
        MG2B,   32, 
        MG2L,   32, 
                Offset (0x1C), 
        DMAX,   8, 
        HPTA,   32, 
        CPB0,   32, 
        CPB1,   32, 
        CPB2,   32, 
        CPB3,   32, 
        ASSB,   8, 
        AOTB,   8, 
        AAXB,   32
    }

    Method (RRIO, 4, NotSerialized)
    {
        Store ("RRIO", Debug)
    }

    Method (RDMA, 3, NotSerialized)
    {
        Store ("rDMA", Debug)
    }

    Name (PICM, 0x00)
    Method (_PIC, 1, NotSerialized)
    {
        If (Arg0)
        {
            Store (0xAA, DBG8)
        }
        Else
        {
            Store (0xAC, DBG8)
        }

        Store (Arg0, PICM)
    }

    Name (OSVR, Ones)
    Method (OSFL, 0, NotSerialized)
    {
        If (LNotEqual (OSVR, Ones))
        {
            Return (OSVR)
        }

        If (LEqual (PICM, 0x00))
        {
            Store (0xAC, DBG8)
        }

        Store (0x01, OSVR)
        If (CondRefOf (\_OSI, Local1))
        {
            If (\_OSI ("Windows 2001"))
            {
                Store (0x00, OSVR)
            }
        }
        Else
        {
            If (MCTH (\_OS, "Microsoft Windows NT"))
            {
                Store (0x04, OSVR)
            }
            Else
            {
                If (MCTH (\_OS, "Microsoft WindowsME: Millennium Edition"))
                {
                    Store (0x02, OSVR)
                }

                If (MCTH (\_OS, "Linux"))
                {
                    Store (0x03, OSVR)
                }
            }
        }

        Return (OSVR)
    }

    Method (MCTH, 2, NotSerialized)
    {
        If (LLess (SizeOf (Arg0), SizeOf (Arg1)))
        {
            Return (Zero)
        }

        Add (SizeOf (Arg0), 0x01, Local0)
        Name (BUF0, Buffer (Local0) {})
        Name (BUF1, Buffer (Local0) {})
        Store (Arg0, BUF0)
        Store (Arg1, BUF1)
        While (Local0)
        {
            Decrement (Local0)
            If (LNotEqual (DerefOf (Index (BUF0, Local0)), DerefOf (Index (
                BUF1, Local0))))
            {
                Return (Zero)
            }
        }

        Return (One)
    }

    Name (PRWP, Package (0x02)
    {
        Zero, 
        Zero
    })
    Method (GPRW, 2, NotSerialized)
    {
        Store (Arg0, Index (PRWP, 0x00))
        Store (ShiftLeft (SS1, 0x01), Local0)
        Or (Local0, ShiftLeft (SS2, 0x02), Local0)
        Or (Local0, ShiftLeft (SS3, 0x03), Local0)
        Or (Local0, ShiftLeft (SS4, 0x04), Local0)
        If (And (ShiftLeft (0x01, Arg1), Local0))
        {
            Store (Arg1, Index (PRWP, 0x01))
        }
        Else
        {
            ShiftRight (Local0, 0x01, Local0)
            If (LOr (LEqual (OSFL (), 0x01), LEqual (OSFL (), 0x02)))
            {
                FindSetLeftBit (Local0, Index (PRWP, 0x01))
            }
            Else
            {
                FindSetRightBit (Local0, Index (PRWP, 0x01))
            }
        }

        Return (PRWP)
    }

    Name (WAKP, Package (0x02)
    {
        Zero, 
        Zero
    })
    OperationRegion (DEB0, SystemIO, DP80, 0x01)
    Field (DEB0, ByteAcc, NoLock, Preserve)
    {
        DBG8,   8
    }

    OperationRegion (DEB1, SystemIO, DP90, 0x02)
    Field (DEB1, WordAcc, NoLock, Preserve)
    {
        DBG9,   16
    }

    Scope (\_PR)
    {
        Processor (CPU1, 0x01, 0x00000510, 0x06) {}
        Processor (CPU2, 0x02, 0x00000000, 0x00) {}
    }

    Scope (\_SB)
    {
        Name (PR00, Package (0x15)
        {
            Package (0x04)
            {
                0x0002FFFF, 
                0x00, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0x0002FFFF, 
                0x01, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0x0002FFFF, 
                0x02, 
                LNED, 
                0x00
            }, 

            Package (0x04)
            {
                0x0002FFFF, 
                0x03, 
                LNEA, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x00, 
                LNEA, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x01, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x02, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x03, 
                LNED, 
                0x00
            }, 

            Package (0x04)
            {
                0x0004FFFF, 
                0x00, 
                LNEA, 
                0x00
            }, 

            Package (0x04)
            {
                0x0004FFFF, 
                0x01, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0x0004FFFF, 
                0x02, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0x0004FFFF, 
                0x03, 
                LNED, 
                0x00
            }, 

            Package (0x04)
            {
                0x000AFFFF, 
                0x00, 
                LSMB, 
                0x00
            }, 

            Package (0x04)
            {
                0x000AFFFF, 
                0x01, 
                LPMU, 
                0x00
            }, 

            Package (0x04)
            {
                0x000BFFFF, 
                0x00, 
                LUB0, 
                0x00
            }, 

            Package (0x04)
            {
                0x000BFFFF, 
                0x01, 
                LUB2, 
                0x00
            }, 

            Package (0x04)
            {
                0x000EFFFF, 
                0x00, 
                LSA0, 
                0x00
            }, 

            Package (0x04)
            {
                0x000FFFFF, 
                0x00, 
                LSA1, 
                0x00
            }, 

            Package (0x04)
            {
                0x0010FFFF, 
                0x01, 
                LAZA, 
                0x00
            }, 

            Package (0x04)
            {
                0x0010FFFF, 
                0x02, 
                LACI, 
                0x00
            }, 

            Package (0x04)
            {
                0x0010FFFF, 
                0x03, 
                LMC9, 
                0x00
            }
        })
        Name (AR00, Package (0x15)
        {
            Package (0x04)
            {
                0x0002FFFF, 
                0x00, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0x0002FFFF, 
                0x01, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0x0002FFFF, 
                0x02, 
                LNED, 
                0x00
            }, 

            Package (0x04)
            {
                0x0002FFFF, 
                0x03, 
                LNEA, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x00, 
                LNEA, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x01, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x02, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x03, 
                LNED, 
                0x00
            }, 

            Package (0x04)
            {
                0x0004FFFF, 
                0x00, 
                LNEA, 
                0x00
            }, 

            Package (0x04)
            {
                0x0004FFFF, 
                0x01, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0x0004FFFF, 
                0x02, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0x0004FFFF, 
                0x03, 
                LNED, 
                0x00
            }, 

            Package (0x04)
            {
                0x000AFFFF, 
                0x00, 
                LSMB, 
                0x00
            }, 

            Package (0x04)
            {
                0x000AFFFF, 
                0x01, 
                LPMU, 
                0x00
            }, 

            Package (0x04)
            {
                0x000BFFFF, 
                0x00, 
                LUB0, 
                0x00
            }, 

            Package (0x04)
            {
                0x000BFFFF, 
                0x01, 
                LUB2, 
                0x00
            }, 

            Package (0x04)
            {
                0x000EFFFF, 
                0x00, 
                LSA0, 
                0x00
            }, 

            Package (0x04)
            {
                0x000FFFFF, 
                0x00, 
                LSA1, 
                0x00
            }, 

            Package (0x04)
            {
                0x0010FFFF, 
                0x01, 
                LAZA, 
                0x00
            }, 

            Package (0x04)
            {
                0x0010FFFF, 
                0x02, 
                LACI, 
                0x00
            }, 

            Package (0x04)
            {
                0x0010FFFF, 
                0x03, 
                LMC9, 
                0x00
            }
        })
        Name (PR08, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                0x00, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x01, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNED, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNEA, 
                0x00
            }
        })
        Name (AR08, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                0x00, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x01, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNED, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNEA, 
                0x00
            }
        })
        Name (PR09, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                0x00, 
                LNEA, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x01, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNED, 
                0x00
            }
        })
        Name (AR09, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                0x00, 
                LNEA, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x01, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNED, 
                0x00
            }
        })
        Name (PR0A, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                0x00, 
                LNEA, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x01, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNED, 
                0x00
            }
        })
        Name (AR0A, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                0x00, 
                LNEA, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x01, 
                LNEB, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNEC, 
                0x00
            }, 

            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNED, 
                0x00
            }
        })
        Name (PR01, Package (0x05)
        {
            Package (0x04)
            {
                0x0001FFFF, 
                0x00, 
                LNKB, 
                0x00
            }, 

            Package (0x04)
            {
                0x0001FFFF, 
                0x01, 
                LNKC, 
                0x00
            }, 

            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                LNKD, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x00, 
                LNKB, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x01, 
                LNKC, 
                0x00
            }
        })
        Name (AR01, Package (0x05)
        {
            Package (0x04)
            {
                0x0001FFFF, 
                0x00, 
                LNKB, 
                0x00
            }, 

            Package (0x04)
            {
                0x0001FFFF, 
                0x01, 
                LNKC, 
                0x00
            }, 

            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                LNKD, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x00, 
                LNKB, 
                0x00
            }, 

            Package (0x04)
            {
                0x0003FFFF, 
                0x01, 
                LNKC, 
                0x00
            }
        })
        Name (PRSA, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {5,7,10,11,14,15}
        })
        Alias (PRSA, PRSB)
        Alias (PRSA, PRSC)
        Alias (PRSA, PRSD)
        Alias (PRSA, RSEA)
        Alias (PRSA, RSEB)
        Alias (PRSA, RSEC)
        Alias (PRSA, RSED)
        Alias (PRSA, RSMB)
        Alias (PRSA, RSB2)
        Alias (PRSA, RSMU)
        Alias (PRSA, RSA1)
        Alias (PRSA, RSA0)
        Alias (PRSA, RSB0)
        Alias (PRSA, RSAC)
        Alias (PRSA, RSZA)
        Alias (PRSA, RSCI)
        Alias (PRSA, RSC9)
        Alias (PRSA, RSTA)
        Name (RSIR, ResourceTemplate ()
        {
            Interrupt (ResourceConsumer, Level, ActiveLow, Shared, ,, )
            {
                0x00000010,
                0x00000011,
                0x00000012,
                0x00000013,
            }
        })
        Name (RSII, ResourceTemplate ()
        {
            Interrupt (ResourceConsumer, Level, ActiveLow, Shared, ,, )
            {
                0x00000014,
                0x00000015,
                0x00000016,
                0x00000017,
            }
        })
        Device (PCI0)
        {
            Name (_HID, EisaId ("PNP0A03"))
            Name (_ADR, 0x00180000)
            Method (^BN00, 0, NotSerialized)
            {
                Return (0x00)
            }

            Method (_BBN, 0, NotSerialized)
            {
                Return (BN00 ())
            }

            Name (_UID, 0x00)
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR00)
                }

                Return (PR00)
            }

            Device (NB2N)
            {
                Name (_ADR, 0x00)
                Method (NPTS, 1, NotSerialized)
                {
                }

                Method (NWAK, 1, NotSerialized)
                {
                }
            }

            Device (P0P8)
            {
                Name (_ADR, 0x00020000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x11, 0x04))
                }

                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR08)
                    }

                    Return (PR08)
                }
            }

            Device (P0P9)
            {
                Name (_ADR, 0x00030000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x11, 0x04))
                }

                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR09)
                    }

                    Return (PR09)
                }

                Device (RTGB)
                {
                    Name (_ADR, 0x00)
                    Method (_PRW, 0, NotSerialized)
                    {
                        Return (GPRW (0x11, 0x04))
                    }
                }
            }

            Device (P0PA)
            {
                Name (_ADR, 0x00040000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x11, 0x04))
                }

                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR0A)
                    }

                    Return (PR0A)
                }

                Device (VGA)
                {
                    Name (_ADR, 0x00)
                    Name (VGAB, Buffer (0x02) {})
                    CreateWordField (VGAB, 0x00, DISD)
                    CreateByteField (VGAB, 0x00, NXTD)
                    CreateByteField (VGAB, 0x01, AVLD)
                    Name (LCDM, 0x01)
                    Name (CRTM, 0x02)
                    Name (TVOM, 0x04)
                    Name (DVIM, 0x08)
                    Name (DONE, 0x00)
                    Name (DOSF, 0x01)
                    Method (_INI, 0, NotSerialized)
                    {
                        Store (GETD (), DISD)
                        Store (One, DONE)
                    }

                    Method (_DOS, 1, NotSerialized)
                    {
                        Store (Arg0, DOSF)
                    }

                    Method (_DOD, 0, NotSerialized)
                    {
                        Return (Package (0x04)
                        {
                            0x00010100, 
                            0x00010118, 
                            0x0200, 
                            0x0120
                        })
                    }

                    Method (CDCS, 1, NotSerialized)
                    {
                        Store (0x0D, Local0)
                        If (And (NXTD, Arg0))
                        {
                            Or (Local0, 0x02, Local0)
                        }

                        If (And (AVLD, Arg0))
                        {
                            Or (Local0, 0x10, Local0)
                        }

                        Return (Local0)
                    }

                    Method (CDGS, 1, NotSerialized)
                    {
                        If (And (NXTD, Arg0))
                        {
                            Return (0x01)
                        }

                        Return (0x00)
                    }

                    Device (CRTD)
                    {
                        Name (_ADR, 0x0100)
                        Method (_DCS, 0, NotSerialized)
                        {
                            Return (CDCS (CRTM))
                        }

                        Method (_DGS, 0, NotSerialized)
                        {
                            Return (CDGS (CRTM))
                        }

                        Method (_DSS, 1, NotSerialized)
                        {
                            If (And (Arg0, 0x40000000))
                            {
                                If (And (Arg0, 0x80000000))
                                {
                                    Store (One, DONE)
                                }
                            }
                        }
                    }

                    Device (TVOD)
                    {
                        Name (_ADR, 0x0200)
                        Method (_DCS, 0, NotSerialized)
                        {
                            Return (CDCS (TVOM))
                        }

                        Method (_DGS, 0, NotSerialized)
                        {
                            Return (CDGS (TVOM))
                        }

                        Method (_DSS, 1, NotSerialized)
                        {
                            If (And (Arg0, 0x40000000))
                            {
                                If (And (Arg0, 0x80000000))
                                {
                                    Store (One, DONE)
                                }
                            }
                        }
                    }

                    Device (LCDD)
                    {
                        Name (_ADR, 0x0118)
                        Method (_DCS, 0, NotSerialized)
                        {
                            Return (CDCS (LCDM))
                        }

                        Method (_DGS, 0, NotSerialized)
                        {
                            Return (CDGS (LCDM))
                        }

                        Method (_DSS, 1, NotSerialized)
                        {
                            If (And (Arg0, 0x40000000))
                            {
                                If (And (Arg0, 0x80000000))
                                {
                                    Store (One, DONE)
                                }
                            }
                        }
                    }

                    Device (DVID)
                    {
                        Name (_ADR, 0x0120)
                        Method (_DCS, 0, NotSerialized)
                        {
                            Return (CDCS (DVIM))
                        }

                        Method (_DGS, 0, NotSerialized)
                        {
                            Return (CDGS (DVIM))
                        }

                        Method (_DSS, 1, NotSerialized)
                        {
                            If (And (Arg0, 0x40000000))
                            {
                                If (And (Arg0, 0x80000000))
                                {
                                    Store (One, DONE)
                                }
                            }
                        }
                    }

                    Method (SWHD, 1, Serialized)
                    {
                        If (\_SB.PCI0.P0PA.VGA.DOSF)
                        {
                            Store (Arg0, PAR1)
                            ISMI (0x73)
                        }
                        Else
                        {
                            Store (Arg0, NXTD)
                            Notify (\_SB.PCI0.P0PA.VGA, 0x80)
                        }

                        Store (One, DONE)
                    }

                    Method (GETD, 0, NotSerialized)
                    {
                        ISMI (0x72)
                        Return (PAR1)
                    }

                    Method (GETM, 0, NotSerialized)
                    {
                        ISMI (0x79)
                        Return (PAR1)
                    }

                    Method (GETN, 0, Serialized)
                    {
                        If (DONE)
                        {
                            Store (GETD (), DISD)
                            Store (GETM (), Local0)
                            If (And (Local0, 0x04))
                            {
                                Return (NXTD)
                            }
                        }

                        Store (0x00, DONE)
                        Increment (NXTD)
                        If (And (NXTD, 0xF0))
                        {
                            Store (0x01, NXTD)
                        }

                        While (LNot (DCHK ()))
                        {
                            Increment (NXTD)
                            If (And (NXTD, 0xF0))
                            {
                                Store (0x01, NXTD)
                            }
                        }

                        Return (NXTD)
                    }

                    Name (NXAV, 0x00)
                    Method (DCHK, 0, NotSerialized)
                    {
                        Not (AVLD, Local0)
                        And (Local0, NXTD, Local0)
                        If (Local0)
                        {
                            Store (0x00, NXAV)
                        }
                        Else
                        {
                            And (NXTD, 0x01, Local1)
                            And (NXTD, 0x02, Local2)
                            And (NXTD, 0x04, Local3)
                            And (NXTD, 0x08, Local4)
                            Add (Local1, ShiftRight (Local2, 0x01), Local1)
                            Add (Local1, ShiftRight (Local3, 0x02), Local1)
                            Add (Local1, ShiftRight (Local4, 0x03), Local1)
                            If (LGreater (Local1, 0x02))
                            {
                                Store (0x00, NXAV)
                            }
                            Else
                            {
                                Store (0xFF, NXAV)
                            }
                        }

                        Return (NXAV)
                    }
                }
            }

            Device (SBRG)
            {
                Name (_ADR, 0x000A0000)
                Method (SPTS, 1, NotSerialized)
                {
                    If (LEqual (Arg0, 0x03))
                    {
                        Store (0x00, LCTM)
                        Store (0x00, LCNM)
                    }

                    Store (Arg0, \_SB.PCI0.IDE0.PTS0)
                    Store (\_SB.PCI0.IDE0.ID20, \_SB.PCI0.IDE0.SID0)
                    Store (\_SB.PCI0.IDE0.IDTS, \_SB.PCI0.IDE0.SID1)
                    Store (\_SB.PCI0.IDE0.IDTP, \_SB.PCI0.IDE0.SID2)
                    Store (\_SB.PCI0.IDE0.ID22, \_SB.PCI0.IDE0.SID3)
                    Store (\_SB.PCI0.IDE0.UMSS, \_SB.PCI0.IDE0.SID4)
                    Store (\_SB.PCI0.IDE0.UMSP, \_SB.PCI0.IDE0.SID5)
                    Store (One, PS1S)
                    Store (One, PS1E)
                    Store (One, \_SB.SLPS)
                }

                Method (SWAK, 1, NotSerialized)
                {
                    Store (Zero, \_SB.SLPS)
                    Store (Zero, PS1E)
                    Store (0x02, S1CT)
                    Store (0x02, S3CT)
                    Store (0x02, S4CT)
                    Store (0x02, S5CT)
                }

                OperationRegion (SMIE, SystemIO, SCIO, 0x08)
                Field (SMIE, ByteAcc, NoLock, Preserve)
                {
                        ,   15, 
                    PS1S,   1, 
                        ,   31, 
                    PS1E,   1, 
                            Offset (0x08)
                }

                OperationRegion (SXCT, SystemIO, SCTL, 0x10)
                Field (SXCT, ByteAcc, NoLock, Preserve)
                {
                    S1CT,   2, 
                            Offset (0x04), 
                    S3CT,   2, 
                            Offset (0x08), 
                    S4CT,   2, 
                            Offset (0x0C), 
                    S5CT,   2, 
                            Offset (0x10)
                }

                Scope (\_SB)
                {
                    OperationRegion (\SCPP, SystemIO, SSMI, 0x01)
                    Field (\SCPP, ByteAcc, NoLock, Preserve)
                    {
                        SMIP,   8
                    }

                    OperationRegion (\APA4, SystemIO, ACA4, 0x04)
                    Field (\APA4, ByteAcc, NoLock, Preserve)
                    {
                                Offset (0x02), 
                        LCTM,   1, 
                        LCNM,   1
                    }

                    Name (SLPS, 0x00)
                    Scope (PCI0)
                    {
                        Method (_S3D, 0, NotSerialized)
                        {
                            If (LEqual (OSFL (), 0x02))
                            {
                                Return (0x02)
                            }
                            Else
                            {
                                Return (0x03)
                            }
                        }

                        Name (_S1D, 0x01)
                        Name (NATA, Package (0x01)
                        {
                            0x00100000
                        })
                        Device (NVRB)
                        {
                            Name (_HID, "NVRAIDBUS")
                            Method (_STA, 0, NotSerialized)
                            {
                                If (And (CPB0, 0x01))
                                {
                                    Return (0x0F)
                                }
                                Else
                                {
                                    Return (0x00)
                                }
                            }

                            Name (_CRS, ResourceTemplate ()
                            {
                                IO (Decode16,
                                    0x04D2,             // Range Minimum
                                    0x04D2,             // Range Maximum
                                    0x01,               // Alignment
                                    0x01,               // Length
                                    )
                            })
                        }
                    }
                }

                Device (PIC)
                {
                    Name (_HID, EisaId ("PNP0000"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0020,             // Range Minimum
                            0x0020,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00A0,             // Range Minimum
                            0x00A0,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IRQNoFlags ()
                            {2}
                    })
                }

                Device (DMAD)
                {
                    Name (_HID, EisaId ("PNP0200"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        DMA (Compatibility, BusMaster, Transfer8, )
                            {4}
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0081,             // Range Minimum
                            0x0081,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0087,             // Range Minimum
                            0x0087,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0089,             // Range Minimum
                            0x0089,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x008F,             // Range Minimum
                            0x008F,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x00C0,             // Range Minimum
                            0x00C0,             // Range Maximum
                            0x00,               // Alignment
                            0x20,               // Length
                            )
                    })
                }

                Device (TMR)
                {
                    Name (_HID, EisaId ("PNP0100"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0040,             // Range Minimum
                            0x0040,             // Range Maximum
                            0x00,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {0}
                    })
                }

                Device (RTC0)
                {
                    Name (_HID, EisaId ("PNP0B00"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0070,             // Range Minimum
                            0x0070,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IRQNoFlags ()
                            {8}
                    })
                }

                Device (PS2K)
                {
                    Name (_HID, EisaId ("PNP0303"))
                    Name (_CID, 0x0B03D041)
                    Method (_STA, 0, NotSerialized)
                    {
                        ShiftLeft (0x01, 0x0A, Local0)
                        If (And (IOST, Local0))
                        {
                            Return (0x0F)
                        }

                        Return (0x00)
                    }

                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {1}
                    })
                }

                Device (PS2M)
                {
                    Name (_HID, EisaId ("SYN0A06"))
                    Name (_CID, 0x130FD041)
                    Method (_STA, 0, NotSerialized)
                    {
                        ShiftLeft (0x01, 0x0C, Local0)
                        If (And (IOST, Local0))
                        {
                            Return (0x0F)
                        }

                        Return (0x00)
                    }

                    Name (CRS1, ResourceTemplate ()
                    {
                        IRQNoFlags ()
                            {12}
                    })
                    Name (CRS2, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {12}
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        ShiftLeft (0x01, 0x0A, Local0)
                        If (And (IOST, Local0))
                        {
                            Return (CRS1)
                        }
                        Else
                        {
                            Return (CRS2)
                        }
                    }
                }

                Device (SPKR)
                {
                    Name (_HID, EisaId ("PNP0800"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0061,             // Range Minimum
                            0x0061,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                    })
                }

                Device (COPR)
                {
                    Name (_HID, EisaId ("PNP0C04"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x00F0,             // Range Minimum
                            0x00F0,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IRQNoFlags ()
                            {13}
                    })
                }

                Device (EC0)
                {
                    Name (_HID, EisaId ("PNP0C09"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0062,             // Range Minimum
                            0x0062,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0066,             // Range Minimum
                            0x0066,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                    })
                    Name (_GPE, 0x20)
                    Name (REGC, 0x00)
                    Method (_REG, 2, NotSerialized)
                    {
                        If (LEqual (Arg0, 0x03))
                        {
                            Store (Arg1, REGC)
                        }
                    }

                    Method (ECAV, 0, NotSerialized)
                    {
                        If (LEqual (REGC, Ones))
                        {
                            If (LGreaterEqual (_REV, 0x02))
                            {
                                Return (One)
                            }
                            Else
                            {
                                Return (Zero)
                            }
                        }

                        Return (REGC)
                    }

                    OperationRegion (ECOR, EmbeddedControl, 0x00, 0x80)
                    Field (ECOR, ByteAcc, Lock, Preserve)
                    {
                                Offset (0x04), 
                        CMD1,   8, 
                        CDT1,   8, 
                        CDT2,   8, 
                        CDT3,   8, 
                                Offset (0x18), 
                        PRTC,   8, 
                        SSTS,   5, 
                            ,   1, 
                        ALFG,   1, 
                        CDFG,   1, 
                        ADDR,   8, 
                        CMDB,   8, 
                        BDAT,   256, 
                        BCNT,   8, 
                            ,   1, 
                        ALAD,   7, 
                        ALD0,   8, 
                        ALD1,   8, 
                        A2AD,   8, 
                        A2D0,   8, 
                        A2D1,   8, 
                        A3AD,   8, 
                        P54D,   8, 
                        P55D,   8, 
                                Offset (0x48), 
                        P54S,   8, 
                        P55S,   8, 
                        P50S,   8, 
                        P43S,   8, 
                        P54T,   8, 
                        P55T,   8, 
                        P50T,   8, 
                        P43T,   8, 
                        P60S,   8, 
                        P61S,   8, 
                        P62S,   8, 
                        P63S,   8, 
                        P64S,   8, 
                        P65S,   8, 
                        P66S,   8, 
                        P67S,   8, 
                        P60T,   8, 
                        P61T,   8, 
                        P62T,   8, 
                        P63T,   8, 
                        P64T,   8, 
                        P65T,   8, 
                        P66T,   8, 
                        P67T,   8, 
                                Offset (0x78), 
                        P60I,   1, 
                        P61I,   1, 
                        P62I,   1, 
                        P63I,   1, 
                        P64I,   1, 
                        P65I,   1, 
                        P66I,   1, 
                        P67I,   1
                    }

                    Field (ECOR, ByteAcc, NoLock, Preserve)
                    {
                                Offset (0x1C), 
                        DAT0,   8, 
                        DAT1,   8
                    }

                    Field (ECOR, ByteAcc, NoLock, Preserve)
                    {
                                Offset (0x1C), 
                        DT2B,   16
                    }

                    Field (ECOR, ByteAcc, Lock, Preserve)
                    {
                                Offset (0x48), 
                            ,   4, 
                        P54A,   1, 
                                Offset (0x49), 
                            ,   4, 
                        P55A,   1, 
                                Offset (0x4A), 
                            ,   4, 
                        P50A,   1, 
                                Offset (0x4B), 
                            ,   4, 
                        P43A,   1
                    }

                    Name (LED2, Ones)
                    Name (LED5, Ones)
                    Name (LED4, Ones)
                    Method (EC0S, 1, NotSerialized)
                    {
                        If (LEqual (Arg0, 0x03))
                        {
                            STC5 (0x2C)
                        }

                        If (Arg0)
                        {
                            If (LLess (Arg0, 0x04))
                            {
                                Not (RDC3 (0x02), LED2)
                                Not (RDC3 (0x05), LED5)
                                If (And (LED2, 0x80))
                                {
                                    STC5 (0x2F)
                                }

                                If (And (LED2, 0x40))
                                {
                                    STC5 (0x2E)
                                }

                                If (And (LED2, 0x20))
                                {
                                    STC5 (0x2D)
                                }

                                Store (RDC3 (0x04), LED4)
                                If (And (LED4, 0x02))
                                {
                                    STC5 (0x51)
                                }

                                STC5 (0x53)
                                WCMD (0xCB)
                            }
                        }
                    }

                    Method (EC0W, 1, NotSerialized)
                    {
                        If (Arg0)
                        {
                            If (LLess (Arg0, 0x04))
                            {
                                If (And (LED2, 0x80))
                                {
                                    STC5 (0x4F)
                                }

                                If (And (LED2, 0x40))
                                {
                                    STC5 (0x4E)
                                }

                                If (And (LED2, 0x20))
                                {
                                    STC5 (0x4D)
                                }

                                If (And (LED4, 0x02))
                                {
                                    STC5 (0x31)
                                }
                            }
                        }
                    }
                }

                Scope (\_SB.PCI0.SBRG.EC0)
                {
                    Mutex (MUEC, 0x00)
                    OperationRegion (DLYP, SystemIO, 0xE1, 0x01)
                    Field (DLYP, ByteAcc, NoLock, Preserve)
                    {
                        DELY,   8
                    }

                    OperationRegion (KBCP, SystemIO, 0x60, 0x07)
                    Field (KBCP, ByteAcc, Lock, Preserve)
                    {
                        KBCD,   8, 
                                Offset (0x02), 
                        EC62,   8, 
                                Offset (0x04), 
                        KBCC,   8, 
                                Offset (0x06), 
                        EC66,   8
                    }

                    Field (KBCP, ByteAcc, Lock, Preserve)
                    {
                                Offset (0x04), 
                        KBOF,   1, 
                        KBIE,   1, 
                                Offset (0x05), 
                                Offset (0x06), 
                        ECOF,   1, 
                        ECIE,   1, 
                                Offset (0x07)
                    }

                    Method (IBFR, 0, Serialized)
                    {
                        Store (0x1000, Local0)
                        While (LAnd (Decrement (Local0), KBIE))
                        {
                            Store (0x00, DELY)
                        }
                    }

                    Method (OBFL, 0, Serialized)
                    {
                        Store (0x1000, Local0)
                        While (LAnd (Decrement (Local0), LNot (KBOF)))
                        {
                            Store (0x00, DELY)
                        }
                    }

                    Method (WKBC, 2, Serialized)
                    {
                        IBFR ()
                        Store (Arg0, KBCC)
                        IBFR ()
                        Store (Arg1, KBCD)
                        IBFR ()
                    }

                    Method (RECR, 1, Serialized)
                    {
                        WKBC (0xB8, Arg0)
                        Store (0xBC, KBCC)
                        IBFR ()
                        OBFL ()
                        Return (KBCD)
                    }

                    Method (WECR, 2, Serialized)
                    {
                        WKBC (0xB8, Arg0)
                        WKBC (0xBD, Arg1)
                    }

                    Method (WCMD, 1, Serialized)
                    {
                        If (ECAV ())
                        {
                            If (LNot (Acquire (MUEC, 0xFFFF)))
                            {
                                Store (Arg0, CMD1)
                                Release (MUEC)
                            }
                        }
                    }

                    Method (ECCM, 3, Serialized)
                    {
                        If (ECAV ())
                        {
                            If (LNot (Acquire (MUEC, 0xFFFF)))
                            {
                                Store (Arg0, CDT1)
                                Store (Arg1, CDT2)
                                Store (Arg2, CMD1)
                                Store (0x1388, Local0)
                                While (LAnd (Decrement (Local0), CMD1))
                                {
                                    Stall (0x0A)
                                }

                                If (CMD1)
                                {
                                    Store (Ones, Local0)
                                }
                                Else
                                {
                                    Store (CDT1, Local0)
                                }

                                Release (MUEC)
                                Return (Local0)
                            }
                        }

                        Return (Ones)
                    }

                    Method (STC5, 1, Serialized)
                    {
                        ECCM (Arg0, 0xFF, 0xC5)
                    }

                    Method (RDC3, 1, Serialized)
                    {
                        Return (ECCM (Arg0, 0xFF, 0xC3))
                    }

                    Method (WEIE, 0, NotSerialized)
                    {
                        Store (0x4000, Local0)
                        While (LAnd (Decrement (Local0), ECIE))
                        {
                            Store (0x00, DELY)
                        }

                        Return (ECIE)
                    }

                    Method (WEOF, 0, NotSerialized)
                    {
                        Store (0x4000, Local0)
                        While (LAnd (Decrement (Local0), LNot (ECOF)))
                        {
                            Store (0x00, DELY)
                        }

                        Return (LNot (ECOF))
                    }

                    Method (ECRD, 1, Serialized)
                    {
                        Store (KSCE, Local1)
                        Store (Zero, KSCE)
                        WEIE ()
                        Store (0x80, EC66)
                        WEIE ()
                        Store (Arg0, EC62)
                        WEIE ()
                        WEOF ()
                        Store (EC62, Local0)
                        While (KSCS)
                        {
                            Store (One, KSCS)
                            Store (0x00, DELY)
                        }

                        Store (Local1, KSCE)
                        Return (Local0)
                    }

                    Method (ECWR, 3, Serialized)
                    {
                        Store (KSCE, Local1)
                        Store (Zero, KSCE)
                        WEIE ()
                        Store (Arg2, EC66)
                        WEIE ()
                        Store (Arg1, EC62)
                        WEIE ()
                        Store (Arg0, EC62)
                        WEIE ()
                        While (KSCS)
                        {
                            Store (One, KSCS)
                        }

                        Store (Local1, KSCE)
                    }

                    Method (ESMR, 3, Serialized)
                    {
                        Store (Ones, Local2)
                        If (ECAV ())
                        {
                            If (LNot (Acquire (MUEC, 0xFFFF)))
                            {
                                Store (0x20, Local0)
                                While (Decrement (Local0))
                                {
                                    Store (0xFFFF, Local1)
                                    While (LAnd (PRTC, Decrement (Local1)))
                                    {
                                        Stall (0x0A)
                                    }

                                    If (PRTC)
                                    {
                                        Continue
                                    }

                                    Store (0x00, SSTS)
                                    Store (0x00, ALFG)
                                    Store (0x00, CDFG)
                                    Stall (0x0A)
                                    Store (Or (Arg0, 0x01), ADDR)
                                    Store (Arg1, CMDB)
                                    Store (Arg2, PRTC)
                                    Store (0x64, Local1)
                                    While (LAnd (PRTC, Decrement (Local1)))
                                    {
                                        Sleep (0x01)
                                    }

                                    If (CDFG)
                                    {
                                        Store (DT2B, Local2)
                                        Break
                                    }
                                }

                                Release (MUEC)
                            }
                        }

                        Return (Local2)
                    }
                }

                Scope (\)
                {
                    Method (ECRB, 1, Serialized)
                    {
                        Store (\_SB.PCI0.SBRG.EC0.ESMR (0x16, Arg0, 0x07), Local0)
                        If (LNotEqual (Local0, Ones))
                        {
                            Return (And (Local0, 0xFF))
                        }

                        Return (Ones)
                    }

                    Method (ECRW, 1, Serialized)
                    {
                        Return (\_SB.PCI0.SBRG.EC0.ESMR (0x16, Arg0, 0x09))
                    }

                    Method (ECIO, 1, Serialized)
                    {
                        Store (\_SB.PCI0.SBRG.EC0.RDC3 (ShiftRight (Arg0, 0x04)), Local0)
                        If (LEqual (Local0, Ones))
                        {
                            Return (Local0)
                        }

                        ShiftRight (Local0, And (Arg0, 0x0F), Local0)
                        Return (And (0x01, Local0))
                    }

                    OperationRegion (SCBX, SystemIO, 0x0800, 0xFF)
                    Field (SCBX, ByteAcc, NoLock, Preserve)
                    {
                                Offset (0xA0), 
                        KSCS,   1, 
                                Offset (0xA8), 
                        KSCE,   1
                    }
                }

                Device (NBRM)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x99)
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y00)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        If (IGPS)
                        {
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.NBRM._Y00._BAS, XB01)
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.NBRM._Y00._LEN, XL01)
                            Store (IGPM, XB01)
                            Store (IGPL, XL01)
                        }

                        Return (CRS)
                    }
                }

                Device (RMSC)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x10)
                    Name (CRS, ResourceTemplate ()
                    {
                        DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                            0x00000000,         // Granularity
                            0x000D0000,         // Range Minimum
                            0x000D3FFF,         // Range Maximum
                            0x00000000,         // Translation Offset
                            0x00004000,         // Length
                            ,, , AddressRangeMemory, TypeStatic)
                        DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                            0x00000000,         // Granularity
                            0x000D4000,         // Range Minimum
                            0x000D7FFF,         // Range Maximum
                            0x00000000,         // Translation Offset
                            0x00004000,         // Length
                            ,, , AddressRangeMemory, TypeStatic)
                        DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                            0x00000000,         // Granularity
                            0x000DE000,         // Range Minimum
                            0x000DFFFF,         // Range Maximum
                            0x00000000,         // Translation Offset
                            0x00002000,         // Length
                            ,, , AddressRangeMemory, TypeStatic)
                        IO (Decode16,
                            0x0010,             // Range Minimum
                            0x0010,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0022,             // Range Minimum
                            0x0022,             // Range Maximum
                            0x00,               // Alignment
                            0x1E,               // Length
                            )
                        IO (Decode16,
                            0x0044,             // Range Minimum
                            0x0044,             // Range Maximum
                            0x00,               // Alignment
                            0x1C,               // Length
                            )
                        IO (Decode16,
                            0x0062,             // Range Minimum
                            0x0062,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0065,             // Range Minimum
                            0x0065,             // Range Maximum
                            0x00,               // Alignment
                            0x0B,               // Length
                            )
                        IO (Decode16,
                            0x0072,             // Range Minimum
                            0x0072,             // Range Maximum
                            0x00,               // Alignment
                            0x0E,               // Length
                            )
                        IO (Decode16,
                            0x0080,             // Range Minimum
                            0x0080,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0084,             // Range Minimum
                            0x0084,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0088,             // Range Minimum
                            0x0088,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x008C,             // Range Minimum
                            0x008C,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0090,             // Range Minimum
                            0x0090,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x00A2,             // Range Minimum
                            0x00A2,             // Range Maximum
                            0x00,               // Alignment
                            0x1E,               // Length
                            )
                        IO (Decode16,
                            0x00E0,             // Range Minimum
                            0x00E0,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x04D0,             // Range Minimum
                            0x04D0,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0800,             // Range Minimum
                            0x0800,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y01)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y02)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y03)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y04)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y05)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y06)
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y07)
                        Memory32Fixed (ReadOnly,
                            0xFEE01000,         // Address Base
                            0x000FF000,         // Address Length
                            )
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y01._MIN, GP00)
                        CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y01._MAX, GP01)
                        CreateByteField (CRS, \_SB.PCI0.SBRG.RMSC._Y01._LEN, GP0L)
                        CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y02._MIN, GP10)
                        CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y02._MAX, GP11)
                        CreateByteField (CRS, \_SB.PCI0.SBRG.RMSC._Y02._LEN, GP1L)
                        Store (PMBS, GP00)
                        Store (PMBS, GP01)
                        If (LGreaterEqual (PMLN, 0x0100))
                        {
                            ShiftRight (PMLN, 0x01, GP0L)
                            Add (GP00, GP0L, GP10)
                            Add (GP01, GP0L, GP11)
                            Subtract (PMLN, GP0L, GP1L)
                        }
                        Else
                        {
                            Store (PMLN, GP0L)
                        }

                        If (SCBS)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y03._MIN, SC00)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y03._MAX, SC01)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.RMSC._Y03._LEN, SC0L)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y04._MIN, SC10)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y04._MAX, SC11)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.RMSC._Y04._LEN, SC1L)
                            Store (SCBS, SC00)
                            Store (SCBS, SC01)
                            If (LGreaterEqual (SCLN, 0x0100))
                            {
                                ShiftRight (SCLN, 0x01, SC0L)
                                Add (SC00, SC0L, SC10)
                                Add (SC01, SC0L, SC11)
                                Subtract (SCLN, SC0L, SC1L)
                            }
                            Else
                            {
                                Store (SCLN, SC0L)
                            }
                        }

                        If (ACBS)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y05._MIN, AC00)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y05._MAX, AC01)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.RMSC._Y05._LEN, AC0L)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y06._MIN, AC10)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y06._MAX, AC11)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.RMSC._Y06._LEN, AC1L)
                            Store (ACBS, AC00)
                            Store (ACBS, AC01)
                            If (LGreaterEqual (ACLN, 0x0100))
                            {
                                ShiftRight (ACLN, 0x01, AC0L)
                                Add (AC00, AC0L, AC10)
                                Add (AC01, AC0L, AC11)
                                Subtract (ACLN, AC0L, AC1L)
                            }
                            Else
                            {
                                Store (ACLN, AC0L)
                            }
                        }

                        CreateDWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y07._BAS, MB01)
                        CreateDWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y07._LEN, ML01)
                        Store (CPB1, MB01)
                        Store (CPB2, ML01)
                        Return (CRS)
                    }
                }

                OperationRegion (\_SB.PCI0.SBRG.LPDC, PCI_Config, 0xA0, 0x06)
                Field (\_SB.PCI0.SBRG.LPDC, ByteAcc, NoLock, Preserve)
                {
                    S3F8,   1, 
                    S2F8,   1, 
                        ,   3, 
                    S2E8,   1, 
                        ,   1, 
                    S3E8,   1, 
                        ,   4, 
                    M300,   1, 
                        ,   2, 
                    M330,   1, 
                        ,   4, 
                    FDC0,   1, 
                            Offset (0x03), 
                    P378,   1, 
                    P278,   1, 
                    P3BC,   1, 
                            Offset (0x04), 
                    G200,   8, 
                    G208,   8
                }

                Method (RRIO, 4, NotSerialized)
                {
                    If (LOr (LEqual (Arg0, 0x00), LEqual (Arg0, 0x01)))
                    {
                        If (LEqual (Arg2, 0x03F8))
                        {
                            Store (Arg1, S3F8)
                        }

                        If (LEqual (Arg2, 0x02F8))
                        {
                            Store (Arg1, S2F8)
                        }

                        If (LEqual (Arg2, 0x03E8))
                        {
                            Store (Arg1, S3E8)
                        }

                        If (LEqual (Arg2, 0x02E8))
                        {
                            Store (Arg1, S2E8)
                        }
                    }

                    If (LEqual (Arg0, 0x02))
                    {
                        If (LEqual (Arg2, 0x0378))
                        {
                            Store (Arg1, P378)
                        }

                        If (LEqual (Arg2, 0x0278))
                        {
                            Store (Arg1, P278)
                        }

                        If (LEqual (Arg2, 0x03BC))
                        {
                            Store (Arg1, P3BC)
                        }
                    }

                    If (LEqual (Arg0, 0x03))
                    {
                        Store (Arg1, FDC0)
                    }

                    If (LEqual (Arg0, 0x05))
                    {
                        If (LEqual (Arg2, 0x0330))
                        {
                            Store (Arg1, M330)
                        }

                        If (LEqual (Arg2, 0x0300))
                        {
                            Store (Arg1, M300)
                        }
                    }

                    If (LEqual (Arg0, 0x08))
                    {
                        Store (Zero, Local0)
                        If (Arg1)
                        {
                            Store (0xFF, Local0)
                        }

                        If (LEqual (Arg2, 0x0200))
                        {
                            Store (Local0, G200)
                        }

                        If (LEqual (Arg2, 0x0208))
                        {
                            Store (Local0, G208)
                        }
                    }
                }

                Method (RDMA, 3, NotSerialized)
                {
                }

                OperationRegion (SMRG, SystemIO, SMBS, 0x10)
                Field (SMRG, ByteAcc, NoLock, Preserve)
                {
                    HSTC,   8, 
                    HSTS,   8, 
                    HADR,   8, 
                    HCMD,   8, 
                    HDT0,   8, 
                    HDT1,   8
                }

                Field (SMRG, ByteAcc, NoLock, Preserve)
                {
                            Offset (0x04), 
                    HDTW,   16
                }

                Method (SCMD, 4, Serialized)
                {
                    Store (0x1F, HSTS)
                    Store (Arg0, HADR)
                    Store (Arg1, HCMD)
                    Store (Arg2, HDTW)
                    Store (Arg3, HSTC)
                    Store (0xFFFF, Local1)
                    While (Decrement (Local1))
                    {
                        Store (HSTS, Local2)
                        If (Local2)
                        {
                            Store (Local2, HSTS)
                            If (LEqual (Local2, 0x80))
                            {
                                Store (HDT0, Local0)
                                Return (Local0)
                            }
                            Else
                            {
                                Store (0x01, Local1)
                            }
                        }
                    }

                    Return (0xFF)
                }

                Method (SBYT, 2, NotSerialized)
                {
                }

                Method (WBYT, 3, NotSerialized)
                {
                    SCMD (Arg0, Arg1, Arg2, 0x06)
                }

                Method (WWRD, 3, NotSerialized)
                {
                    SCMD (Arg0, Arg1, Arg2, 0x08)
                }

                Method (RSBT, 2, NotSerialized)
                {
                }

                Method (RBYT, 2, NotSerialized)
                {
                    Or (Arg0, 0x01, Arg0)
                    Return (SCMD (Arg0, Arg1, 0x00, 0x07))
                }

                Method (RWRD, 2, NotSerialized)
                {
                    Or (Arg0, 0x01, Arg0)
                    Return (SCMD (Arg0, Arg1, 0x00, 0x09))
                }

                Scope (\)
                {
                    OperationRegion (\RAMW, SystemMemory, Subtract (TOPM, 0x00010000), 0x00010000)
                    Field (\RAMW, ByteAcc, NoLock, Preserve)
                    {
                        PAR0,   32, 
                        PAR1,   32
                    }

                    OperationRegion (IOB2, SystemIO, 0x082E, 0x02)
                    Field (IOB2, ByteAcc, NoLock, Preserve)
                    {
                        SMIC,   8, 
                        SMIS,   8
                    }

                    Method (ISMI, 1, Serialized)
                    {
                        Store (Arg0, SMIC)
                    }

                    Method (GNVS, 1, Serialized)
                    {
                        Store (Arg0, PAR0)
                        ISMI (0x70)
                        Return (PAR1)
                    }

                    Method (SNVS, 2, Serialized)
                    {
                        Store (Arg0, PAR0)
                        Store (Arg1, PAR1)
                        ISMI (0x71)
                    }
                }

                Method (\_GPE._L02, 0, NotSerialized)
                {
                    Store (\_SB.PCI0.NPT3.TOFF, Local0)
                    And (Local0, 0x3F, Local0)
                    If (LAnd (LGreater (Local0, 0x00), LLess (Local0, 0x33)))
                    {
                        Store (Local0, \_TZ.COFF)
                    }

                    Store (\_SB.PCI0.NPT3.CPUN, Local0)
                    And (Local0, 0x30, Local0)
                    If (LEqual (Local0, 0x10))
                    {
                        Store (0x01, \_TZ.CNNN)
                    }
                    Else
                    {
                        Store (0x00, \_TZ.CNNN)
                    }

                    Store (GNVS (0x82B0), Local0)
                    If (LAnd (LGreaterEqual (Local0, 0x00), LLess (Local0, 0x10)))
                    {
                        Store (Local0, \_TZ.MFID)
                    }
                    Else
                    {
                        Store (0x00, \_TZ.MFID)
                    }

                    \_TZ.STRP ()
                }

                Scope (\_TZ)
                {
                    Name (HTTL, Package (0x08)
                    {
                        0x39, 
                        0x3F, 
                        0x44, 
                        0x49, 
                        0x4F, 
                        0x55, 
                        0x5F, 
                        0x73
                    })
                    Name (LTTL, Package (0x08)
                    {
                        0x00, 
                        0x32, 
                        0x3A, 
                        0x3F, 
                        0x44, 
                        0x49, 
                        0x50, 
                        0x5A
                    })
                    Name (FSTL, Package (0x08)
                    {
                        0x00, 
                        0x72, 
                        0x88, 
                        0xA0, 
                        0xC4, 
                        0xE5, 
                        0xE5, 
                        0xE5
                    })
                    Name (HTTS, Package (0x08)
                    {
                        0x35, 
                        0x3B, 
                        0x40, 
                        0x45, 
                        0x45, 
                        0x55, 
                        0x5F, 
                        0x73
                    })
                    Name (LTTS, Package (0x08)
                    {
                        0x00, 
                        0x30, 
                        0x35, 
                        0x3B, 
                        0x3B, 
                        0x40, 
                        0x50, 
                        0x5A
                    })
                    Name (FSTS, Package (0x08)
                    {
                        0x00, 
                        0x72, 
                        0x92, 
                        0xB6, 
                        0xE5, 
                        0xE5, 
                        0xE5, 
                        0xE5
                    })
                    Name (TPLO, 0x00)
                    Name (TPHI, 0x00)
                    Name (LTMP, 0x3C)
                    Name (STMP, 0x3C)
                    Name (TCRT, 0x6E)
                    Name (TSP, 0x1E)
                    Name (TC1, 0x02)
                    Name (TC2, 0x0A)
                    Name (CNT, 0x00)
                    Name (COFF, 0x0B)
                    Name (CNNN, 0x01)
                    Name (LFAN, 0x72)
                    Name (MFID, 0x00)
                    Method (KELV, 1, NotSerialized)
                    {
                        And (Arg0, 0xFF, Local0)
                        Multiply (Local0, 0x0A, Local0)
                        Add (Local0, 0x0AAC, Local0)
                        Return (Local0)
                    }

                    Method (CELC, 1, NotSerialized)
                    {
                        Subtract (Arg0, 0x0AAC, Local0)
                        Divide (Local0, 0x0A, Local1, Local0)
                        Return (Local0)
                    }

                    Method (SFLV, 1, Serialized)
                    {
                        \_SB.PCI0.SBRG.EC0.ECCM (Arg0, 0x84, 0xC4)
                    }

                    Method (RTMP, 0, Serialized)
                    {
                        \_SB.PCI0.SBRG.RBYT (0x98, 0x02)
                        Store (\_SB.PCI0.SBRG.RBYT (0x98, 0x01), Local0)
                        If (LLess (Local0, 0x7F))
                        {
                            Store (Local0, LTMP)
                        }

                        Store (COFF, Local0)
                        If (LGreaterEqual (0x0B, Local0))
                        {
                            Subtract (0x0B, Local0, Local0)
                            Add (LTMP, Local0, LTMP)
                        }
                        Else
                        {
                            Subtract (Local0, 0x0B, Local0)
                            Subtract (LTMP, Local0, LTMP)
                        }

                        Return (LTMP)
                    }

                    Method (STRP, 0, NotSerialized)
                    {
                        Store (\_SB.PCI0.SBRG.RBYT (0x98, 0x02), Local1)
                        If (LNotEqual (Local1, 0xFF))
                        {
                            Store (\_SB.PCI0.SBRG.RBYT (0x98, 0x08), TPLO)
                            If (LNotEqual (TPLO, 0x00))
                            {
                                Store (COFF, Local0)
                                If (LGreaterEqual (0x0B, Local0))
                                {
                                    Subtract (0x0B, Local0, Local0)
                                    Add (TPLO, Local0, TPLO)
                                }
                                Else
                                {
                                    Subtract (Local0, 0x0B, Local0)
                                    Subtract (TPLO, Local0, TPLO)
                                }
                            }

                            If (LEqual (CNNN, 0x01))
                            {
                                Store (Match (LTTL, MEQ, TPLO, MTR, 0x00, 0x00), Local0)
                            }
                            Else
                            {
                                Store (Match (LTTS, MEQ, TPLO, MTR, 0x00, 0x00), Local0)
                            }

                            If (LAnd (And (Local1, 0x10), LLess (Local0, 0x07)))
                            {
                                Increment (Local0)
                            }

                            If (LAnd (LEqual (CNNN, 0x00), LEqual (Local0, 0x04)))
                            {
                                Increment (Local0)
                            }

                            If (LAnd (And (Local1, 0x08), LGreater (Local0, 0x00)))
                            {
                                Decrement (Local0)
                            }

                            Store (COFF, Local1)
                            If (LGreaterEqual (0x0B, Local1))
                            {
                                Subtract (0x0B, Local1, Local1)
                                If (LEqual (CNNN, 0x01))
                                {
                                    Subtract (DerefOf (Index (HTTL, Local0)), Local1, Local2)
                                }
                                Else
                                {
                                    Subtract (DerefOf (Index (HTTS, Local0)), Local1, Local2)
                                }
                            }
                            Else
                            {
                                Subtract (Local1, 0x0B, Local1)
                                If (LEqual (CNNN, 0x01))
                                {
                                    Add (DerefOf (Index (HTTL, Local0)), Local1, Local2)
                                }
                                Else
                                {
                                    Add (DerefOf (Index (HTTS, Local0)), Local1, Local2)
                                }
                            }

                            Store (COFF, Local1)
                            If (LNotEqual (Local0, 0x00))
                            {
                                If (LGreaterEqual (0x0B, Local1))
                                {
                                    Subtract (0x0B, Local1, Local1)
                                    If (LEqual (CNNN, 0x01))
                                    {
                                        Subtract (DerefOf (Index (LTTL, Local0)), Local1, Local3)
                                    }
                                    Else
                                    {
                                        Subtract (DerefOf (Index (LTTS, Local0)), Local1, Local3)
                                    }
                                }
                                Else
                                {
                                    Subtract (Local1, 0x0B, Local1)
                                    If (LEqual (CNNN, 0x01))
                                    {
                                        Add (DerefOf (Index (LTTL, Local0)), Local1, Local3)
                                    }
                                    Else
                                    {
                                        Add (DerefOf (Index (LTTS, Local0)), Local1, Local3)
                                    }
                                }
                            }
                            Else
                            {
                                Store (0x00, Local3)
                            }

                            \_SB.PCI0.SBRG.WBYT (0x98, 0x0D, Local2)
                            \_SB.PCI0.SBRG.WBYT (0x98, 0x0E, Local3)
                            Store (DerefOf (Index (\_SB.AMW0.STBC, 0x01)), Local1)
                            If (LOr (LGreater (Local1, 0x7F), LLess (Local1, 0x01)))
                            {
                                Store (0x01, Local1)
                            }

                            If (LGreaterEqual (Local1, 0x5F))
                            {
                                SFLV (0xE5)
                            }
                            Else
                            {
                                If (LEqual (CNNN, 0x01))
                                {
                                    SFLV (DerefOf (Index (FSTL, Local0)))
                                    Store (DerefOf (Index (FSTL, Local0)), LFAN)
                                }
                                Else
                                {
                                    SFLV (DerefOf (Index (FSTS, Local0)))
                                    Store (DerefOf (Index (FSTS, Local0)), LFAN)
                                }
                            }

                            If (LEqual (Local0, 0x05))
                            {
                                Store (0x00, \TENA)
                            }

                            If (LEqual (Local0, 0x06))
                            {
                                If (LGreaterEqual (MFID, 0x0C))
                                {
                                    Store (0x01, \TENA)
                                    Store (0x0C, \TDTY)
                                }
                                Else
                                {
                                    Store (0x00, \TENA)
                                }
                            }

                            If (LEqual (Local0, 0x07))
                            {
                                Store (0x01, \TENA)
                                Store (0x08, \TDTY)
                            }

                            \_SB.PCI0.SBRG.RBYT (0x98, 0x02)
                        }
                    }

                    Method (RSYS, 0, NotSerialized)
                    {
                        Return (And (\_SB.PCI0.SBRG.RBYT (0x98, 0x00), 0xFF))
                    }

                    OperationRegion (\PMBX, SystemIO, 0x0500, 0x20)
                    Field (\PMBX, ByteAcc, NoLock, Preserve)
                    {
                                Offset (0x1F), 
                        FANC,   8
                    }

                    Method (RFAN, 0, NotSerialized)
                    {
                        Store (0x00, Local0)
                        If (\_SB.PCI0.SBRG.EC0.ECAV ())
                        {
                            Store (\_SB.PCI0.SBRG.EC0.ECCM (0x99, 0x44, 0xC4), Local0)
                            Divide (Local0, 0x05, Local1, Local0)
                        }

                        If (LNotEqual (Local0, 0x00))
                        {
                            Store (FANS, Local2)
                            Sleep (0x64)
                            Store (FANS, Local3)
                            If (LEqual (Local2, Local3))
                            {
                                Store (0x00, Local0)
                            }
                        }

                        Return (Local0)
                    }

                    ThermalZone (TZ00)
                    {
                        Name (_TZP, 0x012C)
                        Method (_CRT, 0, NotSerialized)
                        {
                            Return (KELV (TCRT))
                        }

                        Method (_TMP, 0, NotSerialized)
                        {
                            Store (0x05, Local1)
                            While (Local1)
                            {
                                Store (RTMP (), Local0)
                                If (LGreater (Local0, TCRT))
                                {
                                    Decrement (Local1)
                                }
                                Else
                                {
                                    Store (0x00, Local1)
                                }
                            }

                            \_GPE._L02 ()

                            Return (KELV (Local0))
                        }
                    }
                }

                Device (\_SB.PCI0.PCIE)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x11)
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly,
                            0xE0000000,         // Address Base
                            0x10000000,         // Address Length
                            _Y08)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        CreateDWordField (CRS, \_SB.PCI0.PCIE._Y08._BAS, BAS1)
                        CreateDWordField (CRS, \_SB.PCI0.PCIE._Y08._LEN, LEN1)
                        Store (\PCIB, BAS1)
                        Store (\PCIL, LEN1)
                        Return (CRS)
                    }
                }

                Device (OMSC)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x00)
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y09)
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y0A)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        If (APIC)
                        {
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.OMSC._Y09._LEN, ML01)
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.OMSC._Y09._BAS, MB01)
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.OMSC._Y0A._LEN, ML02)
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.OMSC._Y0A._BAS, MB02)
                            Store (0xFEC00000, MB01)
                            Store (0x1000, ML01)
                            Store (0xFEE00000, MB02)
                            Store (0x1000, ML02)
                        }

                        Return (CRS)
                    }
                }

                Device (\_SB.RMEM)
                {
                    Name (_HID, EisaId ("PNP0C01"))
                    Name (_UID, 0x01)
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadWrite,
                            0x00000000,         // Address Base
                            0x000A0000,         // Address Length
                            )
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y0B)
                        Memory32Fixed (ReadOnly,
                            0x000E0000,         // Address Base
                            0x00020000,         // Address Length
                            _Y0C)
                        Memory32Fixed (ReadWrite,
                            0x00100000,         // Address Base
                            0x00000000,         // Address Length
                            _Y0D)
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y0E)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        CreateDWordField (CRS, \_SB.RMEM._Y0B._BAS, BAS1)
                        CreateDWordField (CRS, \_SB.RMEM._Y0B._LEN, LEN1)
                        CreateDWordField (CRS, \_SB.RMEM._Y0C._BAS, BAS2)
                        CreateDWordField (CRS, \_SB.RMEM._Y0C._LEN, LEN2)
                        CreateDWordField (CRS, \_SB.RMEM._Y0D._LEN, LEN3)
                        CreateDWordField (CRS, \_SB.RMEM._Y0E._BAS, BAS4)
                        CreateDWordField (CRS, \_SB.RMEM._Y0E._LEN, LEN4)
                        If (OSFL ()) {}
                        Else
                        {
                            If (MG1B)
                            {
                                If (LGreater (MG1B, 0x000C0000))
                                {
                                    Store (0x000C0000, BAS1)
                                    Subtract (MG1B, BAS1, LEN1)
                                }
                            }
                            Else
                            {
                                Store (0x000C0000, BAS1)
                                Store (0x00020000, LEN1)
                            }

                            If (Add (MG1B, MG1L, Local0))
                            {
                                Store (Local0, BAS2)
                                Subtract (0x00100000, BAS2, LEN2)
                            }
                        }

                        Subtract (MG2B, 0x00100000, LEN3)
                        Add (MG2B, MG2L, BAS4)
                        Subtract (0x00, BAS4, LEN4)
                        Return (CRS)
                    }
                }

                Scope (\)
                {
                    Name (MNAM, "A6T")
                    Field (\RAMW, ByteAcc, NoLock, Preserve)
                    {
                                Offset (0x10), 
                        ACPS,   1, 
                        DCPS,   1, 
                        LCDC,   1, 
                        CPUC,   1, 
                        PLCK,   1, 
                        FANC,   1, 
                        BLTS,   1, 
                        WLAN,   1, 
                                Offset (0xB0), 
                        TRTY,   8, 
                        FSFN,   8, 
                        FSTA,   16, 
                        FADR,   32, 
                        FSIZ,   16
                    }

                    OperationRegion (\PMIO, SystemIO, 0x0500, 0x80)
                    Field (\PMIO, ByteAcc, NoLock, Preserve)
                    {
                                Offset (0x10), 
                        TDTY,   4, 
                        TENA,   1, 
                        TTDT,   4
                    }

                    Method (ATKN, 1, NotSerialized)
                    {
                        If (\_SB.LID._LID ())
                        {
                            Return (ATKR (Arg0))
                        }

                        Return (0x00)
                    }

                    Method (ATKR, 1, NotSerialized)
                    {
                        If (\_SB.ATKP)
                        {
                            Notify (\_SB.ATKD, Arg0)
                            Return (0x01)
                        }

                        Return (0x00)
                    }

                    Name (P4PR, 0x00)
                    Method (NBFS, 1, NotSerialized)
                    {
                        If (LEqual (Arg0, 0x05))
                        {
                            SNVS (0x81E8, GNVS (0x8078))
                        }

                        ISMI (0x76)
                        Store (PAR0, P4PR)
                    }

                    Method (NBWK, 1, NotSerialized)
                    {
                        If (LNot (GNVS (0x13D9)))
                        {
                            Notify (\_SB.PWRB, 0x02)
                        }

                        Store (P4PR, PAR0)
                        ISMI (0x77)
                    }
                }

                Scope (\_SB)
                {
                    Name (ATKP, Zero)
                    Name (TGPU, 0x2D)
                    Device (ATKD)
                    {
                        Name (_HID, "ATK0100")
                        Name (_UID, 0x01010100)
                        Method (INIT, 1, NotSerialized)
                        {
                            Store (One, ATKP)
                            Return (\MNAM)
                        }

                        Method (GPLV, 0, NotSerialized)
                        {
                            Return (GNVS (0x44EC))
                        }

                        Method (SPLV, 1, NotSerialized)
                        {
                            SNVS (0x44EC, Arg0)
                            \_SB.PCI0.SBRG.EC0.STBR ()
                        }

                        Scope (\_SB.PCI0.SBRG.EC0)
                        {
                            Name (PWAC, Buffer (0x10)
                            {
                                /* 0000 */    0x00, 0x18, 0x20, 0x28, 0x30, 0x38, 0x40, 0x48, 
                                /* 0008 */    0x50, 0x58, 0x60, 0x68, 0x70, 0x78, 0x80, 0x8F
                            })
                            Name (PWDC, Buffer (0x10)
                            {
                                /* 0000 */    0x00, 0x08, 0x10, 0x18, 0x20, 0x28, 0x30, 0x38, 
                                /* 0008 */    0x40, 0x48, 0x50, 0x58, 0x60, 0x68, 0x70, 0x78
                            })
                            Method (STBR, 0, Serialized)
                            {
                                Store (GNVS (0x44EC), Local0)
                                Store (DerefOf (Index (PWAC, Local0)), Local1)
                                If (\LCDC)
                                {
                                    If (LNot (\ACPS))
                                    {
                                        Store (DerefOf (Index (PWDC, Local0)), Local1)
                                    }
                                }

                                \_SB.PCI0.SBRG.EC0.ECCM (Local1, 0x85, 0xC4)
                            }

                            Method (_Q69, 0, NotSerialized)
                            {
                                ATKN (0x40)
                            }

                            Method (_Q6A, 0, NotSerialized)
                            {
                                ATKN (0x41)
                            }

                            Method (_Q6B, 0, NotSerialized)
                            {
                                ATKN (0x43)
                            }

                            Method (_Q6C, 0, NotSerialized)
                            {
                                ATKN (0x45)
                            }

                            Method (_Q01, 0, NotSerialized)
                            {
                                ATKN (0x52)
                            }

                            Method (_Q02, 0, NotSerialized)
                            {
                                ATKN (0x53)
                            }

                            Method (_Q03, 0, NotSerialized)
                            {
                                ATKN (0x54)
                            }

                            Method (_Q04, 0, NotSerialized)
                            {
                                ATKN (0x55)
                            }

                            Method (_Q05, 0, NotSerialized)
                            {
                                ATKN (0x56)
                            }

                            Method (_Q2F, 0, NotSerialized)
                            {
                                Store (ECIO (0x55), Local0)
                                If (LNotEqual (Local0, Ones))
                                {
                                    Store (Local0, \DCPS)
                                    If (ECAV ())
                                    {
                                        If (LEqual (Acquire (MUEC, 0xFFFF), 0x00))
                                        {
                                            If (Local0)
                                            {
                                                And (P55S, 0xEF, P55S)
                                            }
                                            Else
                                            {
                                                Or (P55S, 0x10, P55S)
                                            }

                                            Release (MUEC)
                                        }
                                    }

                                    Notify (\_SB.PCI0.BAT0, 0x01)
                                    Notify (\_SB.PCI0.BAT0, 0x81)
                                    Notify (\_SB.PCI0.AC0, 0x80)
                                }
                            }

                            Method (_Q34, 0, NotSerialized)
                            {
                                Sleep (0x01F4)
                                Store (ECIO (0x64), Local0)
                                If (LNotEqual (Local0, Ones))
                                {
                                    Store (Local0, \ACPS)
                                    ATKR (Add (0x57, \ACPS))
                                    STBR ()
                                    Notify (\_SB.PCI0.AC0, 0x80)
                                    Notify (\_SB.PCI0.BAT0, 0x80)
                                    Notify (\_PR.CPU1, 0x80)
                                    Notify (\_PR.CPU1, 0x81)
                                }
                            }

                            Method (_Q50, 0, NotSerialized)
                            {
                                If (LNot (ATKR (0x6E)))
                                {
                                    Notify (\_SB.PCI0.BAT0, 0x80)
                                }
                            }

                            Method (_Q30, 0, NotSerialized)
                            {
                                ATKN (0x50)
                            }

                            Method (_Q31, 0, NotSerialized)
                            {
                                ATKN (0x51)
                            }

                            Method (_Q32, 0, NotSerialized)
                            {
                                ATKN (0x5C)
                            }

                            Method (_Q33, 0, NotSerialized)
                            {
                                Store (ECIO (0x63), PLCK)
                                ATKN (Add (0x6A, PLCK))
                            }

                            Method (_Q36, 0, NotSerialized)
                            {
                                \_SB.PCI0.SBRG.EC0.STC5 (0xC3)
                                Store (0xFF, Local1)
                                While (Decrement (Local1))
                                {
                                    Store (\_SB.PCI0.SBRG.EC0.RDC3 (0x06), Local0)
                                    If (And (Local0, 0x40))
                                    {
                                        Store (0x01, Local1)
                                    }
                                    Else
                                    {
                                        \_SB.PCI0.SBRG.EC0.STC5 (0xC3)
                                    }
                                }
                            }

                            Method (_Q0A, 0, NotSerialized)
                            {
                                Notify (\_SB.SLPB, 0x80)
                            }

                            Method (_Q0B, 0, NotSerialized)
                            {
                                ATKN (0x88)
                            }

                            Method (_Q0D, 0, NotSerialized)
                            {
                                ATKN (0x6D)
                            }

                            Method (_Q0F, 0, NotSerialized)
                            {
                                Store (GNVS (0x44EC), Local0)
                                If (LLess (Local0, 0x0F))
                                {
                                    Increment (Local0)
                                }
                                Else
                                {
                                    Store (0x0F, Local0)
                                }

                                SNVS (0x44EC, Local0)
                                STBR ()
                                ATKN (Add (Local0, 0x10))
                            }

                            Method (_Q0E, 0, NotSerialized)
                            {
                                Store (GNVS (0x44EC), Local0)
                                If (LGreater (Local0, 0x00))
                                {
                                    Decrement (Local0)
                                }

                                If (LGreater (Local0, 0x0E))
                                {
                                    Store (0x0E, Local0)
                                }

                                SNVS (0x44EC, Local0)
                                STBR ()
                                ATKN (Add (Local0, 0x20))
                            }

                            Method (_Q10, 0, NotSerialized)
                            {
                                If (ATKN (Add (0x33, \BKLT)))
                                {
                                    XOr (\BKLT, 0x01, \BKLT)
                                }
                            }

                            Method (_Q11, 0, NotSerialized)
                            {
                                Store (\_SB.PCI0.P0PA.VGA.GETN (), Local0)
                                If (LLess (Local0, 0x08))
                                {
                                    Add (Local0, 0x60, Local0)
                                }
                                Else
                                {
                                    Store (Local0, T00)
                                    If (LEqual (0x08, T00))
                                    {
                                        Store (0x8C, Local0)
                                    }
                                    Else
                                    {
                                        If (LEqual (0x09, T00))
                                        {
                                            Store (0x8D, Local0)
                                        }
                                        Else
                                        {
                                            If (LEqual (0x0A, T00))
                                            {
                                                Store (0x8E, Local0)
                                            }
                                            Else
                                            {
                                                If (LEqual (0x0B, T00))
                                                {
                                                    Store (0x90, Local0)
                                                }
                                                Else
                                                {
                                                    If (LEqual (0x0C, T00))
                                                    {
                                                        Store (0x8F, Local0)
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (0x0D, T00))
                                                        {
                                                            Store (0x91, Local0)
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (0x0E, T00))
                                                            {
                                                                Store (0x92, Local0)
                                                            }
                                                            Else
                                                            {
                                                                If (LEqual (0x0F, T00))
                                                                {
                                                                    Store (0x93, Local0)
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }

                                ATKN (Local0)
                            }

                            Method (_Q13, 0, NotSerialized)
                            {
                                ATKN (0x32)
                            }

                            Method (_Q14, 0, NotSerialized)
                            {
                                ATKN (0x31)
                            }

                            Method (_Q15, 0, NotSerialized)
                            {
                                ATKN (0x30)
                            }
                        }

                        Scope (\_SB)
                        {
                            Device (SLPB)
                            {
                                Name (_HID, EisaId ("PNP0C0E"))
                                Method (_PRW, 0, NotSerialized)
                                {
                                    Return (Package (0x02)
                                    {
                                        0x01, 
                                        0x04
                                    })
                                }
                            }
                        }

                        Method (TMPR, 0, NotSerialized)
                        {
                            Store (\_TZ.KELV (\_TZ.RTMP ()), Local0)
                            Or (ShiftLeft (\_TZ.RFAN (), 0x10), Local0, Local0)
                            If (\TENA)
                            {
                                Or (ShiftLeft (\TDTY, 0x18), Local0, Local0)
                            }

                            Return (Local0)
                        }

                        Method (TRMS, 0, NotSerialized)
                        {
                            Store (0x01, Local0)
                            Store (DerefOf (Index (\_SB.AMW0.STBC, 0x01)), Local0)
                            If (LNotEqual (Local0, 0x00))
                            {
                                Return (\_TZ.KELV (Local0))
                            }
                            Else
                            {
                                Return (\_TZ.KELV (TGPU))
                            }
                        }

                        Method (SFUN, 0, NotSerialized)
                        {
                            Return (0x00020AF7)
                        }

                        Method (SPGS, 1, NotSerialized)
                        {
                            Return (One)
                        }

                        Method (SFRQ, 1, NotSerialized)
                        {
                            Return (One)
                        }

                        Method (GFRQ, 1, NotSerialized)
                        {
                            Return (One)
                        }

                        Method (SDSP, 1, NotSerialized)
                        {
                            \_SB.PCI0.P0PA.VGA.SWHD (Arg0)
                        }

                        Method (FSMI, 1, NotSerialized)
                        {
                            Store (Arg0, \FSFN)
                            Or (Arg0, 0xA0, Local0)
                            ISMI (0x90)
                            Return (\FSTA)
                        }

                        Method (FLSH, 1, NotSerialized)
                        {
                            Store (Arg0, \FSTA)
                            FSMI (0x00)
                        }

                        Method (FINI, 1, NotSerialized)
                        {
                            Store (Arg0, \FADR)
                            Return (FSMI (0x01))
                        }

                        Method (FERS, 1, NotSerialized)
                        {
                            Store (Arg0, \FSTA)
                            Return (FSMI (0x02))
                        }

                        Method (FWRI, 1, NotSerialized)
                        {
                            Store (Arg0, \FADR)
                            Store (0x1000, \FSIZ)
                            Return (Subtract (0x1000, FSMI (0x03)))
                        }

                        Method (FWRP, 0, NotSerialized)
                        {
                            Store (0x00, \FSIZ)
                            Return (Subtract (0x1000, FSMI (0x03)))
                        }

                        Method (FEBW, 1, NotSerialized)
                        {
                            Store (0x84, DBG8)
                            Store (Arg0, \FADR)
                            Return (FSMI (0x04))
                        }

                        Method (FEBR, 1, NotSerialized)
                        {
                            Store (0x85, DBG8)
                            Store (Arg0, \FADR)
                            Return (FSMI (0x05))
                        }

                        Method (FEDW, 0, NotSerialized)
                        {
                            Store (0x86, DBG8)
                            Return (FSMI (0x06))
                        }
                    }
                }

                Scope (\_SB.PCI0)
                {
                    Device (BAT0)
                    {
                        Name (_HID, EisaId ("PNP0C0A"))
                        Name (_UID, 0x00)
                        Name (_PCL, Package (0x01)
                        {
                            \_SB.PCI0
                        })
                        Method (_STA, 0, NotSerialized)
                        {
                            Return (CSTA (0x00))
                        }

                        Method (_BIF, 0, NotSerialized)
                        {
                            If (And (0x10, _STA ()))
                            {
                                CBIF (0x00)
                            }

                            Return (PBIF)
                        }

                        Method (_BST, 0, NotSerialized)
                        {
                            If (And (0x10, _STA ()))
                            {
                                CBST (0x00)
                            }

                            Return (PBST)
                        }
                    }

                    Name (NBIF, Package (0x0D)
                    {
                        0x01, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0x01, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        " ", 
                        " ", 
                        " ", 
                        " "
                    })
                    Name (PBIF, Package (0x0D)
                    {
                        0x01, 
                        0x10CC, 
                        0x1068, 
                        0x01, 
                        0x36D0, 
                        0x01A4, 
                        0xD2, 
                        0x1C, 
                        0x050A, 
                        "A6T", 
                        " ", 
                        "LION", 
                        "ASUS"
                    })
                    Name (BATF, Buffer (0x02) {})
                    CreateWordField (BATF, 0x00, DATW)
                    Method (CSTA, 1, Serialized)
                    {
                        If (\DCPS)
                        {
                            Return (0x0F)
                        }

                        Return (0x1F)
                    }

                    Method (CBIF, 1, Serialized)
                    {
                        Store (ECRW (0x18), DATW)
                        If (LNotEqual (DATW, Ones))
                        {
                            Store (DATW, Index (PBIF, 0x01))
                        }

                        Store (ECRW (0x10), DATW)
                        If (LNotEqual (DATW, Ones))
                        {
                            Store (DATW, Index (PBIF, 0x02))
                            Divide (DATW, 0x0A, Local1, Local2)
                            Store (Local2, Index (PBIF, 0x05))
                            Divide (DATW, 0x14, Local1, Local2)
                            Store (Local2, Index (PBIF, 0x06))
                            Divide (Local2, 0x64, Local1, Local2)
                            Store (Local2, Index (PBIF, 0x07))
                            Multiply (Local2, 0x12, Local1)
                            Store (Local1, Index (PBIF, 0x08))
                        }

                        Store (ECRW (0x19), DATW)
                        If (LNotEqual (DATW, Ones))
                        {
                            Store (DATW, Index (PBIF, 0x04))
                        }
                    }

                    Name (PBST, Package (0x04)
                    {
                        0x00, 
                        0x8000, 
                        0x8000, 
                        0x36B0
                    })
                    Method (CBST, 1, Serialized)
                    {
                        Store (ECRW (0x0A), DATW)
                        If (LNotEqual (DATW, Ones))
                        {
                            If (And (DATW, 0x8000))
                            {
                                Decrement (DATW)
                                Not (DATW, DATW)
                            }

                            Store (DATW, Index (PBST, 0x01))
                        }

                        Store (0x00, Local0)
                        If (\ACPS)
                        {
                            If (LNot (ECIO (0x23)))
                            {
                                Or (Local0, 0x02, Local0)
                            }
                        }
                        Else
                        {
                            Store (0x01, Local0)
                        }

                        Store (Local0, Index (PBST, 0x00))
                        Store (ECRW (0x0F), DATW)
                        If (LNotEqual (DATW, Ones))
                        {
                            Store (DATW, Index (PBST, 0x02))
                        }

                        Store (ECRW (0x09), DATW)
                        If (LNotEqual (DATW, Ones))
                        {
                            Store (DATW, Index (PBST, 0x03))
                        }
                    }
                }

                Scope (\_SB)
                {
                    Scope (PCI0)
                    {
                        Device (AC0)
                        {
                            Name (_HID, "ACPI0003")
                            Method (_PSR, 0, NotSerialized)
                            {
                                Return (\ACPS)
                            }

                            Name (_PCL, Package (0x01)
                            {
                                \_SB.PCI0
                            })
                        }
                    }
                }

                Scope (\_SB.ATKD)
                {
                    Method (RSTS, 0, NotSerialized)
                    {
                        Store (0x00, Local0)
                        If (GNVS (0x15FD))
                        {
                            Or (0x02, Local0, Local0)
                        }

                        If (GNVS (0x15FE))
                        {
                            Or (0x01, Local0, Local0)
                        }

                        Return (Local0)
                    }

                    Method (HWRS, 0, NotSerialized)
                    {
                        Store (0x00, Local0)
                        Or (ShiftLeft (BLTS, 0x08), Local0, Local0)
                        Or (ShiftLeft (WLAN, 0x07), Local0, Local0)
                        Return (Local0)
                    }

                    Method (WLED, 1, NotSerialized)
                    {
                        SNVS (0x15FE, Arg0)
                        If (LAnd (Arg0, WLAN))
                        {
                            Store (0x01, WWED)
                        }
                        Else
                        {
                            If (LAnd (GNVS (0x15FD), BLTS))
                            {
                                Store (0x01, WWED)
                            }
                            Else
                            {
                                Store (0x00, WWED)
                            }
                        }
                    }

                    Method (BLED, 1, NotSerialized)
                    {
                        SNVS (0x15FD, Arg0)
                        If (LAnd (Arg0, BLTS))
                        {
                            Store (0x01, BLTH)
                            Store (0x01, WWED)
                        }
                        Else
                        {
                            Store (0x00, BLTH)
                            If (LAnd (GNVS (0x15FE), WLAN))
                            {
                                Store (0x01, WWED)
                            }
                            Else
                            {
                                Store (0x00, WWED)
                            }
                        }
                    }

                    Method (MLED, 1, NotSerialized)
                    {
                        If (LNot (Arg0))
                        {
                            Store (0x31, Local0)
                        }
                        Else
                        {
                            Store (0x51, Local0)
                        }

                        \_SB.PCI0.SBRG.EC0.STC5 (Local0)
                    }

                    Method (GPID, 0, NotSerialized)
                    {
                        Return (0x0A)
                    }
                }

                Scope (\)
                {
                    OperationRegion (PMS0, SystemIO, 0x0500, 0x30)
                    Field (PMS0, ByteAcc, NoLock, Preserve)
                    {
                                Offset (0x1F), 
                        FANS,   8
                    }

                    Field (SCBX, ByteAcc, NoLock, Preserve)
                    {
                                Offset (0xC1), 
                        CBRT,   1, 
                                Offset (0xC2), 
                        BKLT,   1, 
                                Offset (0xC4), 
                        WWED,   1, 
                                Offset (0xCA), 
                        BLTH,   1, 
                                Offset (0xCE), 
                        PHOT,   1, 
                                Offset (0xD0), 
                        LIDP,   4, 
                            ,   1, 
                        LIDS,   1
                    }
                }

                Scope (\_GPE)
                {
                    Name (LSTR, 0xFF)
                    Method (_L12, 0, Serialized)
                    {
                        While(LEqual (\_SB.LID._LID (), LSTR)) {
                            Sleep(0x80)
                        }

                        Store(\_SB.LID._LID (), LSTR)
                        Notify (\_SB.LID, 0x80)
                    }
                }

                Scope (\_SB)
                {
                    Device (LID)
                    {
                        Name (_HID, EisaId ("PNP0C0D"))
                        Method (_LID, 0, NotSerialized)
                        {
                            Store (0x00, LIDP)
                            Sleep (0x0A)
                            Store (LIDS, Local0)
                            Store (0x08, LIDP)
                            Return (Local0)
                        }
                    }
                }

                Scope (\_SB.PCI0.SBRG)
                {
                    Method (OEMI, 1, NotSerialized)
                    {
                        Store (0x01, PHOT)
                    }

                    Method (OEMS, 0, NotSerialized)
                    {
                        Store (0x00, CBRT)
                    }
                }

                Scope (\_SB)
                {
                    Device (AMW0)
                    {
                        Name (_HID, "PNP0C14")
                        Name (_UID, 0x00)
                        Name (_WDG, Buffer (0x3C)
                        {
                            /* 0000 */    0xA7, 0x1D, 0x85, 0x2E, 0x53, 0xD0, 0x5F, 0x49, 
                            /* 0008 */    0x9D, 0xFA, 0x1A, 0x4A, 0xD6, 0x2E, 0x6A, 0x86, 
                            /* 0010 */    0x41, 0x43, 0x01, 0x00, 0x3B, 0x6D, 0x43, 0x71, 
                            /* 0018 */    0xDD, 0xFB, 0x72, 0x4C, 0xBC, 0xB8, 0x43, 0x5B, 
                            /* 0020 */    0xFE, 0x0D, 0x64, 0xF9, 0x42, 0x43, 0x01, 0x00, 
                            /* 0028 */    0x21, 0x12, 0x90, 0x05, 0x66, 0xD5, 0xD1, 0x11, 
                            /* 0030 */    0xB2, 0xF0, 0x00, 0xA0, 0xC9, 0x06, 0x29, 0x10, 
                            /* 0038 */    0x42, 0x41, 0x01, 0x00
                        })
                        Name (STAC, Buffer (0x04)
                        {
                            /* 0000 */    0x01, 0x32, 0x05, 0x00
                        })
                        Method (WQAC, 1, NotSerialized)
                        {
                            Store ("MXMTCConfigData", Debug)
                            Return (STAC)
                        }

                        Name (STBC, Buffer (0x04)
                        {
                            /* 0000 */    0x01, 0x00, 0x00, 0x00
                        })
                        Method (WQBC, 1, NotSerialized)
                        {
                            Store ("Get MXMTCControlData: STBC = ", Debug)
                            Store (STBC, Debug)
                            Return (STBC)
                        }

                        Method (WSBC, 2, NotSerialized)
                        {
                            Store (Arg1, STBC)
                            If (LGreaterEqual (DerefOf (Index (STBC, 0x01)), 0x5F))
                            {
                                \_TZ.SFLV (0xE5)
                            }
                            Else
                            {
                                \_TZ.SFLV (\_TZ.LFAN)
                            }

                            Store ("Set MXMTCControlData: STBC = ", Debug)
                            Store (STBC, Debug)
                        }

                        Name (WQBA, Buffer (0x02AE)
                        {
                            /* 0000 */    0x46, 0x4F, 0x4D, 0x42, 0x01, 0x00, 0x00, 0x00, 
                            /* 0008 */    0x9E, 0x02, 0x00, 0x00, 0xC0, 0x0B, 0x00, 0x00, 
                            /* 0010 */    0x44, 0x53, 0x00, 0x01, 0x1A, 0x7D, 0xDA, 0x54, 
                            /* 0018 */    0x28, 0xD9, 0x85, 0x00, 0x01, 0x06, 0x18, 0x42, 
                            /* 0020 */    0x10, 0x07, 0x10, 0x0A, 0x4B, 0x61, 0x02, 0xC9, 
                            /* 0028 */    0x21, 0x52, 0x3C, 0x18, 0x94, 0x05, 0x10, 0x43, 
                            /* 0030 */    0x88, 0x57, 0x04, 0x44, 0x04, 0x84, 0xBC, 0x0A, 
                            /* 0038 */    0xB0, 0x29, 0xC0, 0x24, 0x88, 0xFA, 0xF7, 0x87, 
                            /* 0040 */    0x28, 0x09, 0x0E, 0x25, 0x04, 0x42, 0x12, 0x05, 
                            /* 0048 */    0x98, 0x17, 0xA0, 0x5B, 0x80, 0x61, 0x01, 0xB6, 
                            /* 0050 */    0x05, 0x98, 0x16, 0xE0, 0x18, 0x92, 0x4A, 0x03, 
                            /* 0058 */    0xA7, 0x04, 0x96, 0x02, 0x21, 0xA1, 0x02, 0x94, 
                            /* 0060 */    0x0B, 0xF0, 0x2D, 0x40, 0x3B, 0xA2, 0x24, 0x0B, 
                            /* 0068 */    0xB0, 0x0C, 0x23, 0x02, 0x8F, 0x82, 0xA1, 0x71, 
                            /* 0070 */    0x68, 0xEC, 0x30, 0x2C, 0x13, 0x4C, 0x83, 0x38, 
                            /* 0078 */    0x8C, 0xB2, 0x91, 0x45, 0x60, 0xDC, 0x4E, 0x05, 
                            /* 0080 */    0xC8, 0x15, 0x20, 0x4C, 0x80, 0x78, 0x54, 0x61, 
                            /* 0088 */    0x34, 0x07, 0x45, 0xE0, 0x42, 0x63, 0x64, 0x40, 
                            /* 0090 */    0xC8, 0xA3, 0x00, 0xAB, 0xA3, 0xD0, 0xA4, 0x12, 
                            /* 0098 */    0xD8, 0xBD, 0x00, 0x65, 0x02, 0x2C, 0x0A, 0x10, 
                            /* 00A0 */    0x27, 0xC0, 0x9A, 0x00, 0x63, 0x48, 0x32, 0x28, 
                            /* 00A8 */    0x40, 0x9B, 0x00, 0x5B, 0x20, 0x42, 0x0F, 0xD4, 
                            /* 00B0 */    0x19, 0x8A, 0x46, 0x70, 0x02, 0x51, 0x6A, 0x46, 
                            /* 00B8 */    0x11, 0x48, 0xAC, 0x1A, 0x01, 0x85, 0x12, 0x34, 
                            /* 00C0 */    0x46, 0xB0, 0x10, 0x81, 0xC2, 0x86, 0x37, 0x46, 
                            /* 00C8 */    0x98, 0x03, 0x88, 0xD1, 0xFE, 0x20, 0x48, 0x20, 
                            /* 00D0 */    0x05, 0xE3, 0x66, 0x91, 0x46, 0x83, 0x1A, 0x6B, 
                            /* 00D8 */    0x82, 0x63, 0xF7, 0x68, 0x4E, 0xB8, 0x73, 0x01, 
                            /* 00E0 */    0xD2, 0xE7, 0x26, 0x90, 0xA3, 0x3B, 0xB8, 0x3A, 
                            /* 00E8 */    0x07, 0x4D, 0x86, 0xC7, 0xB0, 0x1E, 0x06, 0xD8, 
                            /* 00F0 */    0x29, 0x00, 0xEF, 0x1A, 0x50, 0xD3, 0x3F, 0x78, 
                            /* 00F8 */    0x26, 0x08, 0x0E, 0x35, 0x44, 0x8F, 0x3A, 0xDC, 
                            /* 0100 */    0x09, 0x1C, 0xFB, 0x91, 0x30, 0x88, 0xB3, 0x3B, 
                            /* 0108 */    0x6E, 0xAC, 0xC3, 0xC9, 0x68, 0xD0, 0xA5, 0x0A, 
                            /* 0110 */    0x30, 0x7B, 0x00, 0xD0, 0xD0, 0x12, 0x9C, 0xF6, 
                            /* 0118 */    0x99, 0x84, 0x7E, 0x0F, 0x38, 0x9F, 0x9E, 0x21, 
                            /* 0120 */    0x89, 0xFC, 0x41, 0xA0, 0x46, 0xE6, 0xFF, 0x3F, 
                            /* 0128 */    0xB4, 0xC7, 0x78, 0x5A, 0x31, 0x43, 0x3E, 0x0B, 
                            /* 0130 */    0x1C, 0x16, 0x13, 0x0B, 0xA1, 0x4D, 0x6A, 0x3C, 
                            /* 0138 */    0x40, 0x40, 0xE1, 0xD1, 0x40, 0x08, 0x6F, 0x06, 
                            /* 0140 */    0x9E, 0xAF, 0x09, 0x46, 0x86, 0x90, 0x93, 0xF1, 
                            /* 0148 */    0xA0, 0x06, 0xE0, 0x41, 0xD7, 0x3A, 0x32, 0x8D, 
                            /* 0150 */    0x27, 0xA6, 0x21, 0xCF, 0xE8, 0x00, 0x22, 0xBF, 
                            /* 0158 */    0x32, 0x78, 0x0C, 0x41, 0x02, 0xF9, 0xC4, 0x60, 
                            /* 0160 */    0xB8, 0xC7, 0x81, 0x13, 0x78, 0x02, 0xF0, 0x59, 
                            /* 0168 */    0x40, 0x10, 0x92, 0x00, 0x21, 0x51, 0xE3, 0xA7, 
                            /* 0170 */    0x47, 0x08, 0x7E, 0x7A, 0x78, 0x93, 0x30, 0x28, 
                            /* 0178 */    0x1F, 0xD2, 0x99, 0xF9, 0x90, 0xE1, 0x11, 0xC2, 
                            /* 0180 */    0x07, 0xC4, 0x7B, 0x9F, 0x3B, 0x19, 0xC1, 0x29, 
                            /* 0188 */    0x7B, 0xA4, 0xE0, 0xB0, 0x7E, 0x0E, 0x20, 0xC0, 
                            /* 0190 */    0xAF, 0x0F, 0x8F, 0x0D, 0x09, 0x7C, 0xAE, 0x08, 
                            /* 0198 */    0x8C, 0x1D, 0xAA, 0xFD, 0x0A, 0x40, 0x08, 0x1E, 
                            /* 01A0 */    0xED, 0x51, 0xE0, 0x54, 0x23, 0x1C, 0x2D, 0x78, 
                            /* 01A8 */    0x08, 0x8A, 0x1C, 0x03, 0x4A, 0xCC, 0x18, 0x50, 
                            /* 01B0 */    0x03, 0x38, 0x85, 0xD0, 0xE7, 0x73, 0x04, 0x47, 
                            /* 01B8 */    0x14, 0x25, 0xF6, 0x21, 0x19, 0xDA, 0x08, 0xE1, 
                            /* 01C0 */    0x1F, 0x39, 0x4E, 0xC1, 0xF7, 0x8B, 0x23, 0x3D, 
                            /* 01C8 */    0xAD, 0x23, 0x78, 0x91, 0xF0, 0x08, 0x30, 0xE1, 
                            /* 01D0 */    0xCE, 0x28, 0xA8, 0x38, 0x30, 0xF4, 0xFF, 0x7F, 
                            /* 01D8 */    0x4C, 0x01, 0xDC, 0x7A, 0x3B, 0xA6, 0x80, 0x3E, 
                            /* 01E0 */    0xC0, 0x31, 0x05, 0x50, 0xFC, 0xFF, 0x3F, 0xA6, 
                            /* 01E8 */    0x00, 0x87, 0xA8, 0xC7, 0x14, 0xF4, 0x40, 0x0C, 
                            /* 01F0 */    0x7C, 0x2E, 0xA1, 0x0D, 0xFF, 0x96, 0xC1, 0x8E, 
                            /* 01F8 */    0x03, 0x87, 0x74, 0x6A, 0x8F, 0x28, 0x80, 0x29, 
                            /* 0200 */    0x79, 0x47, 0x14, 0x50, 0x8C, 0x14, 0xD6, 0xF1, 
                            /* 0208 */    0x04, 0x18, 0x05, 0x3C, 0x9B, 0xA0, 0x22, 0x1D, 
                            /* 0210 */    0x4F, 0x80, 0xCE, 0xFF, 0xFF, 0x78, 0x02, 0x58, 
                            /* 0218 */    0xB8, 0x9A, 0xBC, 0x92, 0x84, 0x7D, 0x1E, 0x78, 
                            /* 0220 */    0x1D, 0x89, 0x14, 0xE3, 0x41, 0xE2, 0xB5, 0xE4, 
                            /* 0228 */    0xC1, 0x24, 0x46, 0x98, 0x08, 0x8F, 0x27, 0x1E, 
                            /* 0230 */    0x47, 0xC0, 0xB7, 0x82, 0x28, 0x91, 0x8E, 0x3E, 
                            /* 0238 */    0xC4, 0x83, 0x49, 0x28, 0x63, 0x3E, 0xA3, 0x84, 
                            /* 0240 */    0x89, 0xF9, 0x04, 0x70, 0x22, 0xEF, 0x27, 0x46, 
                            /* 0248 */    0x0A, 0x73, 0x2A, 0x8F, 0x27, 0x2C, 0xC4, 0xF1, 
                            /* 0250 */    0x04, 0xA0, 0x85, 0xE2, 0xE3, 0x09, 0x3A, 0x2C, 
                            /* 0258 */    0x84, 0xFE, 0xFF, 0xC7, 0x13, 0xDC, 0xE1, 0xC1, 
                            /* 0260 */    0xA7, 0x0C, 0xFC, 0x85, 0x0C, 0xC6, 0xF9, 0x04, 
                            /* 0268 */    0x30, 0x24, 0xF0, 0x7C, 0x02, 0xCA, 0xDB, 0x18, 
                            /* 0270 */    0xE6, 0x80, 0x02, 0x8C, 0x14, 0xDA, 0xF4, 0xA9, 
                            /* 0278 */    0xD1, 0xA8, 0x55, 0x83, 0x32, 0x35, 0xCA, 0x34, 
                            /* 0280 */    0xA8, 0xD5, 0xA7, 0x52, 0x63, 0xC6, 0x4C, 0x9C, 
                            /* 0288 */    0x52, 0xBC, 0x6C, 0x8D, 0xDF, 0xF2, 0x9E, 0x09, 
                            /* 0290 */    0x02, 0xB1, 0x20, 0x0A, 0x81, 0x38, 0xCC, 0xF3, 
                            /* 0298 */    0x42, 0x20, 0x96, 0xA2, 0x01, 0x84, 0x85, 0x06, 
                            /* 02A0 */    0xA1, 0x42, 0xA9, 0x05, 0xE2, 0x98, 0x20, 0x34, 
                            /* 02A8 */    0x92, 0x0A, 0x10, 0xF6, 0xFF, 0x07
                        })
                    }
                }
            }

            Device (NSMB)
            {
                Name (_ADR, 0x000A0001)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
            }

            Device (USB0)
            {
                Name (_ADR, 0x000B0000)
                Name (_S1D, 0x01)
                Method (_S3D, 0, NotSerialized)
                {
                    If (LOr (LEqual (OSFL (), 0x01), LEqual (OSFL (), 0x02)))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }

                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0D, 0x04))
                }
            }

            Device (USB2)
            {
                Name (_ADR, 0x000B0001)
                Name (_S1D, 0x01)
                Method (_S3D, 0, NotSerialized)
                {
                    If (LOr (LEqual (OSFL (), 0x01), LEqual (OSFL (), 0x02)))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }

                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x05, 0x03))
                }
            }

            Device (IDE0)
            {
                Name (_ADR, 0x000D0000)
                Name (PTS0, 0x00)
                Name (SID0, 0x00)
                Name (SID1, 0x00)
                Name (SID2, 0x00)
                Name (SID3, 0x00)
                Name (SID4, 0x00)
                Name (SID5, 0x00)
                OperationRegion (IRQM, SystemIO, 0x21, 0x01)
                Field (IRQM, ByteAcc, NoLock, Preserve)
                {
                    IR0M,   1
                }

                Name (REGF, 0x01)
                Method (_REG, 2, NotSerialized)
                {
                    If (LEqual (Arg0, 0x02))
                    {
                        Store (Arg1, REGF)
                    }
                }

                OperationRegion (A090, PCI_Config, 0x50, 0x18)
                Field (A090, DWordAcc, NoLock, Preserve)
                {
                    ID20,   16, 
                            Offset (0x08), 
                    IDTS,   16, 
                    IDTP,   16, 
                    ID22,   32, 
                    UMSS,   16, 
                    UMSP,   16
                }

                Name (TIM0, Package (0x07)
                {
                    Package (0x05)
                    {
                        0x3C, 
                        0x78, 
                        0xB4, 
                        0xF0, 
                        0x0384
                    }, 

                    Package (0x05)
                    {
                        0x11, 
                        0x20, 
                        0x22, 
                        0x47, 
                        0xA8
                    }, 

                    Package (0x07)
                    {
                        0x78, 
                        0x5A, 
                        0x3C, 
                        0x2D, 
                        0x1E, 
                        0x14, 
                        0x0F
                    }, 

                    Package (0x05)
                    {
                        0x05, 
                        0x04, 
                        0x03, 
                        0x02, 
                        0x00
                    }, 

                    Package (0x04)
                    {
                        0x02, 
                        0x01, 
                        0x00, 
                        0x00
                    }, 

                    Package (0x08)
                    {
                        0x02, 
                        0x01, 
                        0x00, 
                        0x00, 
                        0x03, 
                        0x04, 
                        0x05, 
                        0x06
                    }, 

                    Package (0x07)
                    {
                        0x02, 
                        0x01, 
                        0x00, 
                        0x04, 
                        0x05, 
                        0x06, 
                        0x07
                    }
                })
                Name (TMD0, Buffer (0x14) {})
                CreateDWordField (TMD0, 0x00, PIO0)
                CreateDWordField (TMD0, 0x04, DMA0)
                CreateDWordField (TMD0, 0x08, PIO1)
                CreateDWordField (TMD0, 0x0C, DMA1)
                CreateDWordField (TMD0, 0x10, CHNF)
                OperationRegion (CFG2, PCI_Config, 0x58, 0x0C)
                Field (CFG2, DWordAcc, NoLock, Preserve)
                {
                    SSPT,   8, 
                    SMPT,   8, 
                    PSPT,   8, 
                    PMPT,   8, 
                    SSAS,   2, 
                    SMAS,   2, 
                    PSAS,   2, 
                    PMAS,   2, 
                            Offset (0x06), 
                    SDDR,   4, 
                    SDDA,   4, 
                    PDDR,   4, 
                    PDDA,   4, 
                    SSUT,   3, 
                        ,   3, 
                    SSUE,   2, 
                    SMUT,   3, 
                        ,   3, 
                    SMUE,   2, 
                    PSUT,   3, 
                        ,   3, 
                    PSUE,   2, 
                    PMUT,   3, 
                        ,   3, 
                    PMUE,   2
                }

                Name (GMPT, 0x00)
                Name (GMUE, 0x00)
                Name (GMUT, 0x00)
                Name (GSPT, 0x00)
                Name (GSUE, 0x00)
                Name (GSUT, 0x00)
                Device (CHN0)
                {
                    Name (_ADR, 0x00)
                    Method (_GTM, 0, NotSerialized)
                    {
                        Store ("GTM_CHN0", Debug)
                        Return (GTM (PMPT, PMUE, PMUT, PSPT, PSUE, PSUT))
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        Store ("STM_CHN0", Debug)
                        Store (Arg0, Debug)
                        Store (Arg0, TMD0)
                        Store (PMPT, GMPT)
                        Store (PMUE, GMUE)
                        Store (PMUT, GMUT)
                        Store (PSPT, GSPT)
                        Store (PSUE, GSUE)
                        Store (PSUT, GSUT)
                        STM ()
                        Store (GMPT, PMPT)
                        Store (GMUE, PMUE)
                        Store (GMUT, PMUT)
                        Store (GSPT, PSPT)
                        Store (GSUE, PSUE)
                        Store (GSUT, PSUT)
                        Store (GTF (0x00, Arg1), ATA0)
                        Store (GTF (0x01, Arg2), ATA1)
                    }

                    Device (DRV0)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Store ("_GTF_CHN0_DRV0", Debug)
                            Return (Concatenate (RATA (ATA0), FZTF))
                        }
                    }

                    Device (DRV1)
                    {
                        Name (_ADR, 0x01)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Store ("_GTF_CHN0_DRV1", Debug)
                            Return (Concatenate (RATA (ATA1), FZTF))
                        }
                    }
                }

                Device (CHN1)
                {
                    Name (_ADR, 0x01)
                    Method (_GTM, 0, NotSerialized)
                    {
                        Store ("GTM_CHN1", Debug)
                        Return (GTM (SMPT, SMUE, SMUT, SSPT, SSUE, SSUT))
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, Debug)
                        Store (Arg0, TMD0)
                        Store (SMPT, GMPT)
                        Store (SMUE, GMUE)
                        Store (SMUT, GMUT)
                        Store (SSPT, GSPT)
                        Store (SSUE, GSUE)
                        Store (SSUT, GSUT)
                        STM ()
                        Store (GMPT, SMPT)
                        Store (GMUE, SMUE)
                        Store (GMUT, SMUT)
                        Store (GSPT, SSPT)
                        Store (GSUE, SSUE)
                        Store (GSUT, SSUT)
                        Store (GTF (0x00, Arg1), ATA2)
                        Store (GTF (0x01, Arg2), ATA3)
                    }

                    Device (DRV0)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Store ("_GTF_CHN1_DRV0", Debug)
                            Return (Concatenate (RATA (ATA2), FZTF))
                        }
                    }

                    Device (DRV1)
                    {
                        Name (_ADR, 0x01)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Store ("_GTF_CHN1_DRV1", Debug)
                            Return (Concatenate (RATA (ATA3), FZTF))
                        }
                    }
                }

                Method (DRMP, 0, NotSerialized)
                {
                    ShiftRight (CPB0, 0x04, Local1)
                    And (Local1, 0x0F, Local0)
                    Return (Local0)
                }

                Method (GTM, 6, Serialized)
                {
                    Store (Ones, PIO0)
                    Store (Ones, PIO1)
                    Store (Ones, DMA0)
                    Store (Ones, DMA1)
                    Store (0x10, CHNF)
                    If (REGF) {}
                    Else
                    {
                        Return (TMD0)
                    }

                    If (LEqual (PTS0, 0x01))
                    {
                        If (OSFL ())
                        {
                            Store (0x01, IR0M)
                        }
                    }

                    Store (Match (DerefOf (Index (TIM0, 0x01)), MEQ, Arg0, MTR, 
                        0x00, 0x00), Local6)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, 0x00)), Local6)), 
                        Local7)
                    Store (Local7, DMA0)
                    Store (Local7, PIO0)
                    Store (Match (DerefOf (Index (TIM0, 0x01)), MEQ, Arg3, MTR, 
                        0x00, 0x00), Local6)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, 0x00)), Local6)), 
                        Local7)
                    Store (Local7, DMA1)
                    Store (Local7, PIO1)
                    If (Arg1)
                    {
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x05)), Arg2)), 
                            Local5)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x02)), Local5)), 
                            DMA0)
                        Or (CHNF, 0x01, CHNF)
                    }

                    If (Arg4)
                    {
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x05)), Arg5)), 
                            Local5)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x02)), Local5)), 
                            DMA1)
                        Or (CHNF, 0x04, CHNF)
                    }

                    Store (TMD0, Debug)
                    Return (TMD0)
                }

                Method (STM, 0, Serialized)
                {
                    If (REGF) {}
                    Else
                    {
                        Return (0x00)
                    }

                    If (PTS0)
                    {
                        Store (SID0, ID20)
                        Store (SID1, IDTS)
                        Store (SID2, IDTP)
                        Store (SID3, ID22)
                        Store (SID4, UMSS)
                        Store (SID5, UMSP)
                    }
                    Else
                    {
                        Store (ID20, SID0)
                        Store (IDTS, SID1)
                        Store (IDTP, SID2)
                        Store (ID22, SID3)
                        Store (UMSS, SID4)
                        Store (UMSP, SID5)
                    }

                    Store (0x00, PTS0)
                    Store (0x00, GMUE)
                    Store (0x00, GMUT)
                    Store (0x00, GSUE)
                    Store (0x00, GSUT)
                    If (And (CHNF, 0x01))
                    {
                        Store (Match (DerefOf (Index (TIM0, 0x02)), MLE, DMA0, MTR, 
                            0x00, 0x00), Local0)
                        If (LGreater (Local0, 0x06))
                        {
                            Store (0x06, Local0)
                        }

                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x06)), Local0)), 
                            GMUT)
                        Or (GMUE, 0x03, GMUE)
                    }
                    Else
                    {
                        If (Or (LEqual (PIO0, Ones), LEqual (PIO0, 0x00)))
                        {
                            If (And (LLess (DMA0, Ones), LGreater (DMA0, 0x00)))
                            {
                                Store (DMA0, PIO0)
                            }
                        }
                    }

                    If (And (CHNF, 0x04))
                    {
                        Store (Match (DerefOf (Index (TIM0, 0x02)), MLE, DMA1, MTR, 
                            0x00, 0x00), Local0)
                        If (LGreater (Local0, 0x06))
                        {
                            Store (0x06, Local0)
                        }

                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x06)), Local0)), 
                            GSUT)
                        Or (GSUE, 0x03, GSUE)
                    }
                    Else
                    {
                        If (Or (LEqual (PIO1, Ones), LEqual (PIO1, 0x00)))
                        {
                            If (And (LLess (DMA1, Ones), LGreater (DMA1, 0x00)))
                            {
                                Store (DMA1, PIO1)
                            }
                        }
                    }

                    And (Match (DerefOf (Index (TIM0, 0x00)), MGE, PIO0, MTR, 
                        0x00, 0x00), 0x07, Local0)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, 0x01)), Local0)), 
                        Local1)
                    Store (Local1, GMPT)
                    And (Match (DerefOf (Index (TIM0, 0x00)), MGE, PIO1, MTR, 
                        0x00, 0x00), 0x07, Local0)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, 0x01)), Local0)), 
                        Local1)
                    Store (Local1, GSPT)
                    Return (0x00)
                }

                Name (AT01, Buffer (0x07)
                {
                    /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0xEF
                })
                Name (AT02, Buffer (0x07)
                {
                    /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90
                })
                Name (AT03, Buffer (0x07)
                {
                    /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC6
                })
                Name (AT04, Buffer (0x07)
                {
                    /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x91
                })
                Name (ATA0, Buffer (0x1D) {})
                Name (ATA1, Buffer (0x1D) {})
                Name (ATA2, Buffer (0x1D) {})
                Name (ATA3, Buffer (0x1D) {})
                Name (ATAB, Buffer (0x1D) {})
                CreateByteField (ATAB, 0x00, CMDC)
                Method (GTFB, 3, Serialized)
                {
                    Multiply (CMDC, 0x38, Local0)
                    Add (Local0, 0x08, Local1)
                    CreateField (ATAB, Local1, 0x38, CMDX)
                    Multiply (CMDC, 0x07, Local0)
                    CreateByteField (ATAB, Add (Local0, 0x02), A001)
                    CreateByteField (ATAB, Add (Local0, 0x06), A005)
                    Store (Arg0, CMDX)
                    Store (Arg1, A001)
                    Store (Arg2, A005)
                    Increment (CMDC)
                }

                Method (GTF, 2, Serialized)
                {
                    Store ("GTF_Entry", Debug)
                    Store (Arg1, Debug)
                    Store (0x00, CMDC)
                    Name (ID49, 0x0C00)
                    Name (ID59, 0x00)
                    Name (ID53, 0x04)
                    Name (ID63, 0x0F00)
                    Name (ID88, 0x0F00)
                    Name (IRDY, 0x01)
                    Name (PIOT, 0x00)
                    Name (DMAT, 0x00)
                    If (LEqual (SizeOf (Arg1), 0x0200))
                    {
                        CreateWordField (Arg1, 0x62, IW49)
                        Store (IW49, ID49)
                        CreateWordField (Arg1, 0x6A, IW53)
                        Store (IW53, ID53)
                        CreateWordField (Arg1, 0x7E, IW63)
                        Store (IW63, ID63)
                        CreateWordField (Arg1, 0x76, IW59)
                        Store (IW59, ID59)
                        CreateWordField (Arg1, 0xB0, IW88)
                        Store (IW88, ID88)
                    }

                    Store (0xA0, Local7)
                    If (Arg0)
                    {
                        Store (0xB0, Local7)
                        And (CHNF, 0x08, IRDY)
                        If (And (CHNF, 0x10))
                        {
                            Store (PIO1, PIOT)
                        }
                        Else
                        {
                            Store (PIO0, PIOT)
                        }

                        If (And (CHNF, 0x04))
                        {
                            If (And (CHNF, 0x10))
                            {
                                Store (DMA1, DMAT)
                            }
                            Else
                            {
                                Store (DMA0, DMAT)
                            }
                        }
                    }
                    Else
                    {
                        And (CHNF, 0x02, IRDY)
                        Store (PIO0, PIOT)
                        If (And (CHNF, 0x01))
                        {
                            Store (DMA0, DMAT)
                        }
                    }

                    If (LAnd (LAnd (And (ID53, 0x04), And (ID88, 0xFF00
                        )), DMAT))
                    {
                        Store (Match (DerefOf (Index (TIM0, 0x02)), MLE, DMAT, MTR, 
                            0x00, 0x00), Local1)
                        If (LGreater (Local1, 0x06))
                        {
                            Store (0x06, Local1)
                        }

                        GTFB (AT01, Or (0x40, Local1), Local7)
                    }
                    Else
                    {
                        If (LAnd (And (ID63, 0xFF00), PIOT))
                        {
                            And (Match (DerefOf (Index (TIM0, 0x00)), MGE, PIOT, MTR, 
                                0x00, 0x00), 0x03, Local0)
                            Or (0x20, DerefOf (Index (DerefOf (Index (TIM0, 0x04)), Local0
                                )), Local1)
                            GTFB (AT01, Local1, Local7)
                        }
                    }

                    If (IRDY)
                    {
                        And (Match (DerefOf (Index (TIM0, 0x00)), MGE, PIOT, MTR, 
                            0x00, 0x00), 0x07, Local0)
                        Or (0x08, DerefOf (Index (DerefOf (Index (TIM0, 0x03)), Local0
                            )), Local1)
                        GTFB (AT01, Local1, Local7)
                    }
                    Else
                    {
                        If (And (ID49, 0x0400))
                        {
                            GTFB (AT01, 0x01, Local7)
                        }
                    }

                    If (LAnd (And (ID59, 0x0100), And (ID59, 0xFF)))
                    {
                        GTFB (AT03, And (ID59, 0xFF), Local7)
                    }

                    Store ("ATAB_GTF", Debug)
                    Store (ATAB, Debug)
                    Return (ATAB)
                }

                Method (RATA, 1, NotSerialized)
                {
                    CreateByteField (Arg0, 0x00, CMDN)
                    Multiply (CMDN, 0x38, Local0)
                    CreateField (Arg0, 0x08, Local0, RETB)
                    Store (RETB, Debug)
                    Return (RETB)
                }
            }

            Device (ATA0)
            {
                Name (_ADR, 0x000E0000)
                Device (PRI0)
                {
                    Name (_ADR, 0x00)
                    Name (SPTM, Buffer (0x14)
                    {
                        /* 0000 */    0x78, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x00, 
                        /* 0008 */    0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
                        /* 0010 */    0x13, 0x00, 0x00, 0x00
                    })
                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (SPTM)
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, SPTM)
                    }

                    Device (MAST)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            If (SSEN)
                            {
                                Store (SSEP, SMIP)
                            }

                            Store (Buffer (0x07)
                                {
                                    /* 0000 */    0x03, 0x46, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                }, Local0)
                            Return (Concatenate (Local0, FZTF))
                        }
                    }
                }

                Device (SEC0)
                {
                    Name (_ADR, 0x01)
                    Name (SSTM, Buffer (0x14)
                    {
                        /* 0000 */    0x78, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x00, 
                        /* 0008 */    0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
                        /* 0010 */    0x13, 0x00, 0x00, 0x00
                    })
                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (SSTM)
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, SSTM)
                    }

                    Device (MAST)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            If (SSEN)
                            {
                                Store (SSEP, SMIP)
                            }

                            Store (Buffer (0x07)
                                {
                                    /* 0000 */    0x03, 0x46, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                }, Local0)
                            Return (Concatenate (Local0, FZTF))
                        }
                    }
                }

                Method (DRMP, 0, NotSerialized)
                {
                    Store (0x0C, Local0)
                    If (LEqual (_ADR, 0x000E0000))
                    {
                        Store (0x08, Local0)
                    }

                    ShiftRight (CPB0, Local0, Local1)
                    And (Local1, 0x0F, Local0)
                    Return (Local0)
                }
            }

            Device (ATA1)
            {
                Name (_ADR, 0x000F0000)
                Device (PRI0)
                {
                    Name (_ADR, 0x00)
                    Name (SPTM, Buffer (0x14)
                    {
                        /* 0000 */    0x78, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x00, 
                        /* 0008 */    0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
                        /* 0010 */    0x13, 0x00, 0x00, 0x00
                    })
                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (SPTM)
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, SPTM)
                    }

                    Device (MAST)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            If (SSEN)
                            {
                                Store (SSEP, SMIP)
                            }

                            Store (Buffer (0x07)
                                {
                                    /* 0000 */    0x03, 0x46, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                }, Local0)
                            Return (Concatenate (Local0, FZTF))
                        }
                    }
                }

                Device (SEC0)
                {
                    Name (_ADR, 0x01)
                    Name (SSTM, Buffer (0x14)
                    {
                        /* 0000 */    0x78, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x00, 
                        /* 0008 */    0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
                        /* 0010 */    0x13, 0x00, 0x00, 0x00
                    })
                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (SSTM)
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, SSTM)
                    }

                    Device (MAST)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            If (SSEN)
                            {
                                Store (SSEP, SMIP)
                            }

                            Store (Buffer (0x07)
                                {
                                    /* 0000 */    0x03, 0x46, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                }, Local0)
                            Return (Concatenate (Local0, FZTF))
                        }
                    }
                }

                Method (DRMP, 0, NotSerialized)
                {
                    Store (0x0C, Local0)
                    If (LEqual (_ADR, 0x000E0000))
                    {
                        Store (0x08, Local0)
                    }

                    ShiftRight (CPB0, Local0, Local1)
                    And (Local1, 0x0F, Local0)
                    Return (Local0)
                }
            }

            Device (P0P1)
            {
                Name (_ADR, 0x00100000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x00, 0x04))
                }

                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR01)
                    }

                    Return (PR01)
                }

                Device (CBC)
                {
                    Name (_ADR, 0x00010000)
                    OperationRegion (CBR0, PCI_Config, 0x00, 0xE2)
                    Field (CBR0, DWordAcc, NoLock, Preserve)
                    {
                                Offset (0x44), 
                        C044,   32
                    }

                    Method (_STA, 0, NotSerialized)
                    {
                        Return (0x0F)
                    }

                    Method (_INI, 0, NotSerialized)
                    {
                        Store (0x00, C044)
                    }

                    Method (_PRW, 0, NotSerialized)
                    {
                        Return (GPRW (0x10, 0x03))
                    }
                }

                Device (FIRE)
                {
                    Name (_ADR, 0x00010001)
                    Method (_PRW, 0, NotSerialized)
                    {
                        Return (GPRW (0x10, 0x03))
                    }
                }

                Device (WLAN)
                {
                    Name (_ADR, 0x0003FFFF)
                    Method (_PRW, 0, NotSerialized)
                    {
                        Return (GPRW (0x00, 0x04))
                    }
                }
            }

            Device (HDAC)
            {
                Name (_ADR, 0x00100001)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x15, 0x04))
                }
            }

            Device (MC97)
            {
                Name (_ADR, 0x00100003)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x07, 0x04))
                }
            }

            Device (NPT3)
            {
                Name (_ADR, 0x00180003)
                OperationRegion (CPUT, PCI_Config, 0xE4, 0x06)
                Field (CPUT, ByteAcc, NoLock, Preserve)
                {
                            Offset (0x01), 
                    TOFF,   8, 
                            Offset (0x03), 
                            Offset (0x04), 
                            Offset (0x05), 
                    CPUN,   8
                }
            }
        }

        Scope (\_GPE)
        {
            Method (_L11, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.P0P8, 0x02)
                Notify (\_SB.PCI0.P0P9, 0x02)
                Notify (\_SB.PCI0.P0P9.RTGB, 0x02)
                Notify (\_SB.PCI0.P0PA, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }

            Method (_L09, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.NSMB, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }

            Method (_L0D, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.USB0, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }

            Method (_L05, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.USB2, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }

            Method (_L00, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.P0P1, 0x02)
                Notify (\_SB.PCI0.P0P1.WLAN, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }

            Method (_L10, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.P0P1.CBC, 0x02)
                Notify (\_SB.PCI0.P0P1.FIRE, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }

            Method (_L15, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.HDAC, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }

            Method (_L07, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.MC97, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
        }

        Device (PWRB)
        {
            Name (_HID, EisaId ("PNP0C0C"))
            Name (_UID, 0xAA)
            Name (_STA, 0x0B)
        }
    }

    OperationRegion (\_SB.PCI0.SBRG.PIMC, PCI_Config, 0x7C, 0x0C)
    Field (\_SB.PCI0.SBRG.PIMC, ByteAcc, NoLock, Preserve)
    {
        PIRA,   4, 
        PIRB,   4, 
        PIRC,   4, 
        PIRD,   4, 
        PREA,   4, 
        PREB,   4, 
        PREC,   4, 
        PRED,   4, 
            ,   4, 
                Offset (0x05), 
        PIRM,   4, 
        PIU2,   4, 
            ,   4, 
        PMUD,   4, 
        SIID,   4, 
        PIID,   4, 
        PIU0,   4, 
        PIU1,   4, 
        PILN,   4, 
        PAZA,   4, 
        PAUI,   4, 
        PIMO,   4, 
        PR0E,   4
    }

    Scope (\_SB)
    {
        Name (BUFA, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, _Y0F)
                {15}
        })
        CreateWordField (BUFA, \_SB._Y0F._INT, ICRS)
        Method (LSTA, 1, NotSerialized)
        {
            If (Arg0)
            {
                Return (0x0B)
            }
            Else
            {
                Return (0x09)
            }
        }

        Method (LPRS, 2, NotSerialized)
        {
            If (PICM)
            {
                Return (Arg1)
            }
            Else
            {
                Return (Arg0)
            }
        }

        Method (LCRS, 1, NotSerialized)
        {
            If (PICM)
            {
                Name (BUFB, ResourceTemplate ()
                {
                    Interrupt (ResourceConsumer, Level, ActiveLow, Shared, ,, _Y10)
                    {
                        0x00000011,
                    }
                })
                CreateByteField (BUFB, \_SB.LCRS._Y10._INT, AIRQ)
                Store (Arg0, AIRQ)
                If (LEqual (Arg0, 0x01))
                {
                    Store (0x17, AIRQ)
                }

                If (LEqual (Arg0, 0x02))
                {
                    Store (0x16, AIRQ)
                }

                If (LEqual (Arg0, 0x03))
                {
                    Store (0x10, AIRQ)
                }

                If (LEqual (Arg0, 0x04))
                {
                    Store (0x11, AIRQ)
                }

                If (LEqual (Arg0, 0x06))
                {
                    Store (0x12, AIRQ)
                }

                If (LEqual (Arg0, 0x08))
                {
                    Store (0x14, AIRQ)
                }

                If (LEqual (Arg0, 0x0C))
                {
                    Store (0x13, AIRQ)
                }

                If (LEqual (Arg0, 0x0D))
                {
                    Store (0x15, AIRQ)
                }

                Return (BUFB)
            }
            Else
            {
                ShiftLeft (0x01, Arg0, ICRS)
                Return (BUFA)
            }
        }

        Method (LCRO, 1, NotSerialized)
        {
            If (PICM)
            {
                Name (BUFB, ResourceTemplate ()
                {
                    Interrupt (ResourceConsumer, Level, ActiveLow, Shared, ,, _Y11)
                    {
                        0x00000014,
                    }
                })
                CreateByteField (BUFB, \_SB.LCRO._Y11._INT, AIRQ)
                Store (Arg0, AIRQ)
                If (LEqual (Arg0, 0x01))
                {
                    Store (0x17, AIRQ)
                }

                If (LEqual (Arg0, 0x02))
                {
                    Store (0x16, AIRQ)
                }

                If (LEqual (Arg0, 0x03))
                {
                    Store (0x10, AIRQ)
                }

                If (LEqual (Arg0, 0x04))
                {
                    Store (0x11, AIRQ)
                }

                If (LEqual (Arg0, 0x06))
                {
                    Store (0x12, AIRQ)
                }

                If (LEqual (Arg0, 0x08))
                {
                    Store (0x14, AIRQ)
                }

                If (LEqual (Arg0, 0x0C))
                {
                    Store (0x13, AIRQ)
                }

                If (LEqual (Arg0, 0x0D))
                {
                    Store (0x15, AIRQ)
                }

                Return (BUFB)
            }
            Else
            {
                ShiftLeft (0x01, Arg0, ICRS)
                Return (BUFA)
            }
        }

        Method (LSRS, 1, NotSerialized)
        {
            If (PICM)
            {
                CreateByteField (Arg0, 0x05, SAIR)
                Store (SAIR, Local0)
                If (LEqual (Local0, 0x17))
                {
                    Store (0x01, Local0)
                }

                If (LEqual (Local0, 0x16))
                {
                    Store (0x02, Local0)
                }

                If (LEqual (Local0, 0x10))
                {
                    Store (0x03, Local0)
                }

                If (LEqual (Local0, 0x11))
                {
                    Store (0x04, Local0)
                }

                If (LEqual (Local0, 0x12))
                {
                    Store (0x06, Local0)
                }

                If (LEqual (Local0, 0x14))
                {
                    Store (0x08, Local0)
                }

                If (LEqual (Local0, 0x13))
                {
                    Store (0x0C, Local0)
                }

                If (LEqual (Local0, 0x15))
                {
                    Store (0x0D, Local0)
                }

                Return (Local0)
            }
            Else
            {
                CreateWordField (Arg0, 0x01, ISRS)
                FindSetRightBit (ISRS, Local0)
                Return (Decrement (Local0))
            }
        }

        Method (LSRO, 1, NotSerialized)
        {
            If (PICM)
            {
                CreateByteField (Arg0, 0x05, SAIR)
                Store (SAIR, Local0)
                If (LEqual (Local0, 0x14))
                {
                    Store (0x08, Local0)
                }

                If (LEqual (Local0, 0x15))
                {
                    Store (0x0D, Local0)
                }

                If (LEqual (Local0, 0x16))
                {
                    Store (0x02, Local0)
                }

                If (LEqual (Local0, 0x17))
                {
                    Store (0x01, Local0)
                }

                Return (Local0)
            }
            Else
            {
                CreateWordField (Arg0, 0x01, ISRS)
                FindSetRightBit (ISRS, Local0)
                Return (Decrement (Local0))
            }
        }

        Device (LNKA)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x01)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PIRA))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (PRSA, RSIR))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PIRA)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRS (PIRA))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRS (Arg0), PIRA)
            }
        }

        Device (LNKB)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x02)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PIRB))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (PRSB, RSIR))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PIRB)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRS (PIRB))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRS (Arg0), PIRB)
            }
        }

        Device (LNKC)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x03)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PIRC))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (PRSC, RSIR))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PIRC)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRS (PIRC))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRS (Arg0), PIRC)
            }
        }

        Device (LNKD)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x04)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PIRD))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (PRSD, RSIR))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PIRD)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRS (PIRD))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRS (Arg0), PIRD)
            }
        }

        Device (LNEA)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x01)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PREA))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (PRSA, RSIR))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PREA)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRS (PREA))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRS (Arg0), PREA)
            }
        }

        Device (LNEB)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x02)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PREB))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (PRSB, RSIR))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PREB)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRS (PREB))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRS (Arg0), PREB)
            }
        }

        Device (LNEC)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x03)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PREC))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (PRSC, RSIR))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PREC)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRS (PREC))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRS (Arg0), PREC)
            }
        }

        Device (LNED)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x04)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PRED))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (PRSD, RSIR))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PRED)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRS (PRED))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRS (Arg0), PRED)
            }
        }

        Device (LUB0)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x05)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PIU0))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSB0, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PIU0)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRO (PIU0))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), PIU0)
            }
        }

        Device (LUB2)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x07)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PIU2))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSB2, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PIU2)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRO (PIU2))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), PIU2)
            }
        }

        Device (LMAC)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x08)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PILN))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSAC, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PILN)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRO (PILN))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), PILN)
            }
        }

        Device (LAZA)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x09)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PAZA))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSZA, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PAZA)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRO (PAZA))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), PAZA)
            }
        }

        Device (LACI)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x0A)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PAUI))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSCI, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PAUI)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRO (PAUI))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), PAUI)
            }
        }

        Device (LMC9)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x0B)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PIMO))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSC9, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PIMO)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRO (PIMO))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), PIMO)
            }
        }

        Device (LSMB)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x0C)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PIRM))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSMB, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PIRM)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRO (PIRM))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), PIRM)
            }
        }

        Device (LPMU)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x0D)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PMUD))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSMU, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PMUD)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRO (PMUD))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), PMUD)
            }
        }

        Device (LSA0)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x0E)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PIID))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSA0, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PIID)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRO (PIID))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), Local0)
                Store (Local0, PIID)
            }
        }

        Device (LSA1)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x0F)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (SIID))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSA1, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, SIID)
            }

            Method (_CRS, 0, NotSerialized)
            {
                Return (LCRO (SIID))
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), Local0)
                Store (Local0, SIID)
            }
        }

        Device (LATA)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x10)
            Method (_STA, 0, NotSerialized)
            {
                Return (LSTA (PR0E))
            }

            Method (_PRS, 0, NotSerialized)
            {
                Return (LPRS (RSTA, RSII))
            }

            Method (_DIS, 0, NotSerialized)
            {
                Store (0x00, PR0E)
            }

            Method (_CRS, 0, NotSerialized)
            {
                If (OSFL ())
                {
                    Return (0x00)
                }
                Else
                {
                    Return (LCRO (PR0E))
                }
            }

            Method (_SRS, 1, NotSerialized)
            {
                Store (LSRO (Arg0), PR0E)
            }
        }
    }

    Scope (\_SB)
    {
        Name (XCPD, 0x00)
        Name (XNPT, 0x01)
        Name (XCAP, 0x02)
        Name (XDCP, 0x04)
        Name (XDCT, 0x08)
        Name (XDST, 0x0A)
        Name (XLCP, 0x0C)
        Name (XLCT, 0x10)
        Name (XLST, 0x12)
        Name (XSCP, 0x14)
        Name (XSCT, 0x18)
        Name (XSST, 0x1A)
        Name (XRCT, 0x1C)
        Mutex (MUTE, 0x00)
        Method (RBPE, 1, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            Add (Arg0, \PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x01)
            Field (PCFG, ByteAcc, NoLock, Preserve)
            {
                XCFG,   8
            }

            Release (MUTE)
            Return (XCFG)
        }

        Method (RWPE, 1, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            And (Arg0, 0xFFFFFFFE, Arg0)
            Add (Arg0, \PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x02)
            Field (PCFG, WordAcc, NoLock, Preserve)
            {
                XCFG,   16
            }

            Release (MUTE)
            Return (XCFG)
        }

        Method (RDPE, 1, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            And (Arg0, 0xFFFFFFFC, Arg0)
            Add (Arg0, \PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x04)
            Field (PCFG, DWordAcc, NoLock, Preserve)
            {
                XCFG,   32
            }

            Release (MUTE)
            Return (XCFG)
        }

        Method (WBPE, 2, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            Add (Arg0, \PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x01)
            Field (PCFG, ByteAcc, NoLock, Preserve)
            {
                XCFG,   8
            }

            Store (Arg1, XCFG)
            Release (MUTE)
        }

        Method (WWPE, 2, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            And (Arg0, 0xFFFFFFFE, Arg0)
            Add (Arg0, \PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x02)
            Field (PCFG, WordAcc, NoLock, Preserve)
            {
                XCFG,   16
            }

            Store (Arg1, XCFG)
            Release (MUTE)
        }

        Method (WDPE, 2, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            And (Arg0, 0xFFFFFFFC, Arg0)
            Add (Arg0, \PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x04)
            Field (PCFG, DWordAcc, NoLock, Preserve)
            {
                XCFG,   32
            }

            Store (Arg1, XCFG)
            Release (MUTE)
        }

        Method (RWDP, 3, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            And (Arg0, 0xFFFFFFFC, Arg0)
            Add (Arg0, \PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x04)
            Field (PCFG, DWordAcc, NoLock, Preserve)
            {
                XCFG,   32
            }

            And (XCFG, Arg2, Local1)
            Or (Local1, Arg1, XCFG)
            Release (MUTE)
        }

        Method (RPME, 1, NotSerialized)
        {
            Add (Arg0, 0x84, Local0)
            Store (\_SB.RDPE (Local0), Local1)
            If (LEqual (Local1, 0xFFFFFFFF))
            {
                Return (0x00)
            }
            Else
            {
                If (LAnd (Local1, 0x00010000))
                {
                    \_SB.WDPE (Local0, And (Local1, 0x00010000))
                    Return (0x01)
                }

                Return (0x00)
            }
        }
    }

    Name (HBAS, 0x00)
    Name (HLBA, 0x00)
    Name (HDEV, 0x00)
    OperationRegion (REFP, SystemIO, 0x61, 0x01)
    Field (REFP, ByteAcc, NoLock, Preserve)
    {
        P061,   8
    }

    Method (FZHD, 0, NotSerialized)
    {
        Store (0x80, Local0)
        Store (DMAX, Local1)
        While (LLessEqual (Local0, Local1))
        {
            And (Local0, 0x7F, Local3)
            Store (0x01, Local2)
            ShiftLeft (Local2, Local3, Local2)
            If (LNot (And (\_SB.PCI0.HFZF, Local2)))
            {
                If (FZOD (Local0))
                {
                    Or (\_SB.PCI0.HFZF, Local2, \_SB.PCI0.HFZF)
                }
            }

            Increment (Local0)
        }
    }

    Method (FZOD, 1, NotSerialized)
    {
        GHET (Arg0)
        If (LEqual (HBAS, 0x00))
        {
            Return (0x01)
        }

        If (LEqual (HDEV, 0x00))
        {
            Return (0x01)
        }

        Store (HDEV, Local1)
        And (Local1, 0x10, Local1)
        If (LEqual (Local1, 0x00))
        {
            Return (0x01)
        }

        SDRV ()
        Add (HBAS, 0x07, Local1)
        OperationRegion (HRGS, SystemIO, Local1, 0x01)
        Field (HRGS, ByteAcc, NoLock, Preserve)
        {
            SREG,   8
        }

        Store (SREG, Local1)
        And (Local1, 0x80, Local1)
        If (Local1)
        {
            Return (0x00)
        }

        Add (HBAS, 0x07, Local1)
        OperationRegion (HRGC, SystemIO, Local1, 0x01)
        Field (HRGC, ByteAcc, NoLock, Preserve)
        {
            CREG,   8
        }

        Store (0xF5, CREG)
        If (WFCF ())
        {
            Add (HBAS, 0x07, Local0)
            Store (SREG, Local1)
            Return (LNot (And (Local1, 0x01)))
        }
        Else
        {
            Return (0x00)
        }
    }

    OperationRegion (DBGA, SystemIO, 0x80, 0x04)
    Field (DBGA, DWordAcc, NoLock, Preserve)
    {
        DB32,   32
    }

    Method (GHET, 1, NotSerialized)
    {
        And (Arg0, 0x7F, Local0)
        ShiftLeft (Local0, 0x05, Local0)
        Add (Local0, HPTA, Local0)
        OperationRegion (HDPT, SystemMemory, Local0, 0x20)
        Field (HDPT, ByteAcc, NoLock, Preserve)
        {
            HP00,   16, 
                    Offset (0x04), 
            HP04,   8, 
                    Offset (0x12), 
            HP0C,   8
        }

        Store (HP00, HBAS)
        Store (HP04, HLBA)
        Store (HP0C, HDEV)
    }

    Method (SDRV, 0, NotSerialized)
    {
        Add (HBAS, 0x06, Local0)
        OperationRegion (HRGH, SystemIO, Local0, 0x01)
        Field (HRGH, ByteAcc, NoLock, Preserve)
        {
            HREG,   8
        }

        Store (HLBA, HREG)
    }

    Method (WFCF, 0, NotSerialized)
    {
        SDRV ()
        Add (HBAS, 0x01, Local0)
        OperationRegion (HRGE, SystemIO, Local0, 0x01)
        Field (HRGE, ByteAcc, NoLock, Preserve)
        {
            EREG,   8
        }

        Store (0x00, EREG)
        Add (HBAS, 0x07, Local1)
        OperationRegion (HRGC, SystemIO, Local1, 0x01)
        Field (HRGC, ByteAcc, NoLock, Preserve)
        {
            CREG,   8
        }

        Store (0x28, Local0)
        While (Local0)
        {
            And (CREG, 0x01, Local2)
            If (Local2)
            {
                Return (0x00)
            }

            WFZF (Local1)
            And (CREG, 0x80, Local2)
            If (LEqual (Local2, 0x00))
            {
                Return (0x01)
            }

            Decrement (Local0)
        }

        Return (0x00)
    }

    Method (WFZF, 1, NotSerialized)
    {
        OperationRegion (HRGC, SystemIO, Arg0, 0x01)
        Field (HRGC, ByteAcc, NoLock, Preserve)
        {
            CREG,   8
        }

        Store (0xFFFF, Local1)
        While (Local1)
        {
            Store (CREG, Local2)
            And (Local2, 0x80, Local2)
            If (LEqual (Local2, 0x00))
            {
                Return (Zero)
            }
	    
	    Stall (0x0F)
            Decrement (Local1)
	    
            If (LEqual (Local1, 0x00))
            {
                Return (Zero)
            }
        }
	
	Return(Zero)
    }

    Scope (\_SB.PCI0)
    {
        Name (HFZF, 0x00)
        Method (HWAK, 1, NotSerialized)
        {
            If (LEqual (Arg0, 0x03))
            {
                Store (0x00, HFZF)
            }
        }
    }

    Name (FZTF, Buffer (0x07)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF5
    })
    Name (AGES, 0xAA5555AA)
    Scope (\_PR.CPU1)
    {
        Name (_PCT, Package (0x02)
        {
            ResourceTemplate ()
            {
                Register (FFixedHW, 
                    0x00,               // Bit Width
                    0x00,               // Bit Offset
                    0x0000000000000000, // Address
                    ,)
            }, 

            ResourceTemplate ()
            {
                Register (FFixedHW, 
                    0x00,               // Bit Width
                    0x00,               // Bit Offset
                    0x0000000000000000, // Address
                    ,)
            }
        })
        Name (_PSS, Package (0x02)
        {
            Package (0x06)
            {
                0x00000640, 
                0x00019A28, 
                0x00000064, 
                0x00000009, 
                0xE02024C8, 
                0x000004C8
            }, 

            Package (0x06)
            {
                0x00000320, 
                0x00007193, 
                0x00000064, 
                0x00000009, 
                0xE0202780, 
                0x00000780
            }
        })
        Name (_PPC, 0x00)
        Name (_PSD, Package (0x01)
        {
            Package (0x05)
            {
                0x05, 
                0x00, 
                0x00000000, 
                0x000000FD,
		0x00000002
            }
        })
    }

    Scope (\_PR.CPU2)
    {
        Name (_PCT, Package (0x02)
        {
            ResourceTemplate ()
            {
                Register (FFixedHW, 
                    0x00,               // Bit Width
                    0x00,               // Bit Offset
                    0x0000000000000000, // Address
                    ,)
            }, 

            ResourceTemplate ()
            {
                Register (FFixedHW, 
                    0x00,               // Bit Width
                    0x00,               // Bit Offset
                    0x0000000000000000, // Address
                    ,)
            }
        })
        Name (_PSS, Package (0x02)
        {
            Package (0x06)
            {
                0x00000640, 
                0x00019A28, 
                0x00000064, 
                0x00000009, 
                0xE02024C8, 
                0x000004C8
            }, 

            Package (0x06)
            {
                0x00000320, 
                0x00007193, 
                0x00000064, 
                0x00000009, 
                0xE0202780, 
                0x00000780
            }
        })
        Name (_PPC, 0x00)
        Name (_PSD, Package (0x01)
        {
            Package (0x05)
            {
                0x05, 
                0x00, 
                0x00000000, 
                0x000000FD,
		0x00000002
            }
        })
    }

    Name (A009, Buffer (0x33)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x08, 0x41, 0x30, 0x30, 0x39, 0x11, 
        /* 0010 */    0x36, 0x0A, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0020 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0028 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0030 */    0x00, 0x00, 0x00
    })
    Name (A010, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A011, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A012, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A013, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A014, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A015, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A016, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A017, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A018, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A019, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A020, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A021, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A022, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A023, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A024, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A025, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A026, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A027, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A028, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A029, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A030, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A031, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A032, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A033, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A034, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A035, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A036, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A037, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A038, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A039, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A040, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A041, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A042, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A043, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A044, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A045, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A046, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A047, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A048, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A049, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A050, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A051, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A052, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A053, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A054, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A055, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A056, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A057, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A058, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A059, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A060, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A061, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A062, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A063, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A064, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A065, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A066, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A067, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A068, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A069, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A070, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A071, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A072, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A073, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A074, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A075, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A076, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A077, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A078, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A079, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A080, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A081, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A082, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A083, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A084, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A085, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A086, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A087, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A088, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A089, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A090, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A091, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A092, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A093, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A094, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A095, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A096, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A097, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A098, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A099, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0A0, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0A1, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0A2, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0A3, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0A4, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0A5, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0A6, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0A7, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0A8, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0A9, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0B0, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0B1, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0B2, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0B3, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0B4, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0B5, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0B6, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0B7, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0B8, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0B9, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0C0, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0C1, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0C2, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Name (A0C3, Buffer (0x20)
    {
        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
        /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    })
    Scope (\_SB)
    {
        Scope (PCI0)
        {
            Name (CRS, ResourceTemplate ()
            {
                WordBusNumber (ResourceProducer, MinFixed, MaxFixed, PosDecode,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x00FF,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0100,             // Length
                    ,, )
                IO (Decode16,
                    0x0CF8,             // Range Minimum
                    0x0CF8,             // Range Maximum
                    0x01,               // Alignment
                    0x08,               // Length
                    )
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x0CF7,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0CF8,             // Length
                    ,, , TypeStatic)
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0D00,             // Range Minimum
                    0xFFFF,             // Range Maximum
                    0x0000,             // Translation Offset
                    0xF300,             // Length
                    ,, , TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000A0000,         // Range Minimum
                    0x000BFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00020000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000C0000,         // Range Minimum
                    0x000DFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00020000,         // Length
                    ,, _Y12, AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x00000000,         // Range Minimum
                    0x00000000,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00000000,         // Length
                    ,, _Y13, AddressRangeMemory, TypeStatic)
            })
            CreateDWordField (CRS, \_SB.PCI0._Y12._MIN, MIN5)
            CreateDWordField (CRS, \_SB.PCI0._Y12._MAX, MAX5)
            CreateDWordField (CRS, \_SB.PCI0._Y12._LEN, LEN5)
            CreateDWordField (CRS, \_SB.PCI0._Y13._MIN, MIN6)
            CreateDWordField (CRS, \_SB.PCI0._Y13._MAX, MAX6)
            CreateDWordField (CRS, \_SB.PCI0._Y13._LEN, LEN6)
            Method (_CRS, 0, NotSerialized)
            {
                Store (MG1L, Local0)
                If (Local0)
                {
                    Store (MG1B, MIN5)
                    Store (MG1L, LEN5)
                    Add (MIN5, Decrement (Local0), MAX5)
                }

                Store (MG2B, MIN6)
                Store (MG2L, LEN6)
                Store (MG2L, Local0)
                Add (MIN6, Decrement (Local0), MAX6)
                Return (CRS)
            }
        }
    }

    Name (WOTB, 0x00)
    Name (WSSB, 0x00)
    Name (WAXB, 0x00)
    Method (_PTS, 1, NotSerialized)
    {
        Store (Arg0, DBG8)
        PTS (Arg0)
        Store (0x00, Index (WAKP, 0x00))
        Store (0x00, Index (WAKP, 0x01))
        If (LAnd (LEqual (Arg0, 0x04), LEqual (OSFL (), 0x02)))
        {
            Sleep (0x0BB8)
        }

        Store (ASSB, WSSB)
        Store (AOTB, WOTB)
        Store (AAXB, WAXB)
        Store (Arg0, ASSB)
        Store (OSFL (), AOTB)
        Store (Zero, AAXB)
    }

    Method (_WAK, 1, NotSerialized)
    {
        ShiftLeft (Arg0, 0x04, DBG8)
        WAK (Arg0)
        If (ASSB)
        {
            Store (WSSB, ASSB)
            Store (WOTB, AOTB)
            Store (WAXB, AAXB)
        }

        If (DerefOf (Index (WAKP, 0x00)))
        {
            Store (0x00, Index (WAKP, 0x01))
        }
        Else
        {
            Store (Arg0, Index (WAKP, 0x01))
        }
	
        Return (WAKP)
    }

    Name (\_S0, Package (0x04)
    {
        0x00, 
        0x00, 
        0x00, 
        0x00
    })
    If (SS1)
    {
        Name (\_S1, Package (0x04)
        {
            0x01, 
            0x00, 
            0x00, 
            0x00
        })
    }

    If (SS3)
    {
        Name (\_S3, Package (0x04)
        {
            0x05, 
            0x00, 
            0x00, 
            0x00
        })
    }

    If (SS4)
    {
        Name (\_S4, Package (0x04)
        {
            0x06, 
            0x00, 
            0x00, 
            0x00
        })
    }

    Name (\_S5, Package (0x04)
    {
        0x07, 
        0x00, 
        0x00, 
        0x00
    })
    Method (PTS, 1, NotSerialized)
    {
        If (Arg0)
        {
            \_SB.PCI0.SBRG.EC0.EC0S (Arg0)
            \_SB.PCI0.SBRG.SPTS (Arg0)
            \_SB.PCI0.NB2N.NPTS (Arg0)
            \_SB.PCI0.SBRG.OEMS ()
            \NBFS (Arg0)
        }
    }

    Method (WAK, 1, NotSerialized)
    {
        \_SB.PCI0.SBRG.EC0.EC0W (Arg0)
        \_SB.PCI0.HWAK (Arg0)
        \_SB.PCI0.SBRG.SWAK (Arg0)
        \_SB.PCI0.NB2N.NWAK (Arg0)
        \_SB.PCI0.SBRG.OEMI (Arg0)
        \NBWK (Arg0)
    }
}

